'gbDesigner v0.904, Gary Beene
#Compile Exe
#Dim All
'#Debug Error On     'catch array/pointer errors - OFF in production
'#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32api.inc"
#Include "CommCtrl.inc"
#Resource "gbdesigner.pbr"


'Application Control Equates ======================================================
%IDC_CodeBox           = 300
%IDC_ToolbarA          = 301
%IDC_pListBox          = 302
%IDC_zListBox          = 303
%IDC_ToolbarB          = 304
%IDC_ToolbarC          = 305

'Control Equates (reserve 400 through 599 for supported controls)
%IDM_Select            = 400
%IDM_Button            = 401
%IDM_Check3State       = 402
%IDM_CheckBox          = 403
%IDM_ComboBox          = 404
%IDM_Frame             = 405
%IDM_Graphic           = 406
%IDM_Image             = 407
%IDM_ImageX            = 408
%IDM_ImgButton         = 409
%IDM_ImgButtonX        = 410
%IDM_Label             = 411
%IDM_Line              = 412
%IDM_ListBox           = 413
%IDM_ListView          = 414
%IDM_Option            = 415
%IDM_ProgressBar       = 416
%IDM_HScrollBar        = 417
%IDM_VScrollBar        = 418
%IDM_StatusBar         = 419
%IDM_Tab               = 420
%IDM_TextBox           = 421
%IDM_Toolbar           = 422
%IDM_TreeView          = 423
'400 ... thru 599 reserved for controls

'Misc ======================================================
%IDM_Sep               = 600
%IDM_Debug             = 601
%IDM_ZCommand          = 602

'Toolbar Equates =============================================
%IDM_LeftRight         = 700
%IDM_New               = 701
%IDM_Open              = 702
%IDM_Save              = 703
%IDM_SaveAs            = 704

%IDM_DesignMode        = 705
%IDM_LineMode          = 706

%IDM_DeleteAll         = 707
%IDM_Undo              = 708

%IDM_OpenInIDE         = 709
%IDM_CopyCode          = 710
%IDM_DisplayCodeBox    = 711
%IDM_ShowCode          = 712

'Actions Context Menu ===================================
%IDM_SelectAll         = 750
%IDM_UnselectAll       = 751

%IDM_DeleteSelected    = 752
'delete all                  'in toolbar list

'show code                   'in toolbar list
'copy code                   'in toolbar list
%IDM_DialogCapture     = 754

'new/open/save/saveas        'in toolbar list
%IDM_Restore           = 755

%IDM_SetGridSize       = 756
%IDM_SetDisplayGridSize = 757
%IDM_SetTabOrder       = 758
%IDM_AlignAllToGrid    = 759

%IDM_WebSite           = 760

'Settings Context Menu ===================================
'design mode                 'in toolbar list
'line mode                   'in toolbar list
%IDM_DisplayToolbar    = 800
'displaycodebox              'in toolbar list

%IDM_SnapToGrid        = 802
%IDM_ShowGrid          = 803

%IDM_ConfirmDeleteAll  = 804
%IDM_AutoSaveRestore   = 805

%IDM_FloatingToolbar   = 806
%IDM_LineModeLabels    = 807
%IDM_NumericLabels     = 808

%IDM_UseExpandedCode   = 809
%IDM_SDKCode           = 810
%IDM_AutoCopyCode      = 811

'Control Context Menu ===================================
%IDM_ControlDelete     = 850
'delete all selected            'in toolbar list
%IDM_Properties        = 851
'open in IDE                    'in toolbar list


'Control Context Equates ===============================
%IDM_CodeDelete        = 900
%IDM_CodeCut           = 901
%IDM_CodeCopy          = 902
%IDM_CodePaste         = 903
%IDM_CodeCopyAll       = 904

'Macros =======================================================================
Macro DebugLog(sText)
If Debug Then cPrint sText
End Macro

'Custom UDT ====================================================================
Type ControlType
    x1         As Long   'upper left
    y1         As Long   'upper left
    x2         As Long   'lower right
    y2         As Long   'lower right
    cType      As Long   'unqiue to this application (see equates above)
    cID        As Long   'control ID #
    sel        As Long   'selected
    fontsize   As Long   'pts
    fontattr   As Long   'bold/italic/underline/strikethru
    fontcolor  As Long
    style      As Long   'OR combination of values
    extstyle   As Long   'OR combination of values
    oldProc    As Long   'original control procedure
    handle     As Long   'handle
    dragdeltax As Long   'working variable
    dragdeltay As Long   'working variable
    lng01 As Long        'reserved
    lng02 As Long        'reserved
    lng03 As Long        'reserved
    lng04 As Long        'reserved
    lng05 As Long        'reserved
    lng06 As Long        'reserved
    lng07 As Long        'reserved
    lng08 As Long        'reserved
    lng09 As Long        'reserved
    lng10 As Long        'reserved
    cName     As Asciiz * %Max_Path  'something like %IDC_Textbox01, to create equates for exported code
    txt       As Asciiz * %Max_Path  'text string
    fontname  As Asciiz * %Max_Path  'text string
    imagefile As Asciiz * %Max_Path  'external file
    resname   As Asciiz * %Max_Path  'resource
    propfile  As Asciiz * %Max_Path  'external file containing properties
    tooltip   As Asciiz * %Max_Path  'tooltip string
    str01 As String * 255        'reserved
    str02 As String * 255        'reserved
    str03 As String * 255        'reserved
    str04 As String * 255        'reserved
    str05 As String * 255        'reserved
    str06 As String * 255        'reserved
    str07 As String * 255        'reserved
    str08 As String * 255        'reserved
    str09 As String * 255        'reserved
    str10 As String * 255        'reserved
End Type

'Global handles   ============================================
Global hDlg, hDC, hDialogContext, hControlContext, hCodeContext, hCode, hConsole,hOverlayDlg As Dword
Global hCodeLst,hActions,hSettings, hProperty, hOrder, hFont, hFloatDlg, hImageList As Dword

'Current Design Data
Global cList() As ControlType, ContextControl As Long
Global BaseID As Long

'Global Code Output ======================================
Global UseExpandedCode, SDKCode, AutoCopyCode As Long
Global ControlNames(), ControlCodeStd(), ControlCodeExp() As String
Global cCode, dialogtemplate As String

'Global MISC variables  ===================================
Global INIFileName As Asciiz * %Max_Path, dFlag, Debug As Long

'Global GUI Information ===================================
Global DisplayCodeBox, DisplayToolbar, ExpandToolbar, OrigCodeProc, NumericLabels As Long
Global FloatingToolbar, ShowGrid, DesignMode As Long, CFN As String
Global SA, SC As String  'these 3 used in dialog caption
Global AutoSaveRestore, ConfirmDeleteAll, LineModeLabels, iMsgCount As Long

'Global Drawing ===========================================
Global hDC, hBMP, memDC As Dword
Global dragdeltax, dragdeltay, ctlDrag, ctlResize, ctlCorner As Long
Global yCodeBox, yToolbar, SnapToGrid, LineMode As Long
Global pt, ptDrawOrig, ptDragOrig, truept As Point, DrawInWork, CurrentControlType As Long
Global ResizeControlInWork, MoveInWork, DisplayGridSize, GridSize, CurrentControl As Long
Global SelectBoxSize, resizeptx, resizepty As Long

'Globall Property Dialog ==================================
Global pArray() As String

'Global Floating Dialog ===================================
Global FLeft, FTop, FWidth, FHeight, SDKCode As Long


Function PBMain()
    ReDim cList(0)
    Dialog New Pixels, 0, "gbDesigner",300,300,500,350, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
'    Control aDd Button, hDlg, %IDOk, "",50,50,50,50
    Dialog Set Icon hDlg, "aaa"
    CreateContextMenu
    Dialog Show Modal hDlg Call DlgProc()
End Function

CallBack Function DlgProc() As Long
   Local w,h,iReturn As Long, tempASciiZ As Asciiz * %Max_Path
   Select Case Cb.Msg
      Case %WM_InitDialog
         'debug option
         Getprivateprofilestring "All", "Debug", "0", tempAsciiZ, %Max_Path, INIFileName
         Debug = Val(tempAsciiZ)
         'general setup
         INIFileName = EXE.Path$ + "gbdesigner.ini"   'defines file name (any file name will work)
         SetControlNames
         LoadControlCode
         LoadDialogTemplate
         CreateImageList
         CreateCodeImageList
         CreateMainToolbar
         CreateInvisibleBitmap
         CreateCodeBox
         BuildAcceleratorTable
         'read INI for settings
         Settings_INI "get"
         If IsFalse(IsFile(CFN)) Then CFN = EXE.Path$ + "temp.gbd"
         CreateFloatingDialog     'needs INI values
         DesignModeSettings
         If ExpandToolbar = 0 Then ReSizeToolbar
         If AutoSaveRestore Then OpenCFN(0,0)   'zero is for startup only
         DisplayCaption

         'transparent overlay
         Dialog New Pixels, hDlg, "", 0,0,0,0, %WS_Popup Or %WS_Visible Or %WS_Border, %WS_Ex_Layered To hOverlayDlg
         Dialog Show Modeless hOverlayDlg, Call OverLayProc
      Case %WM_NCActivate
          If IsFalse(Cb.WParam) Then Function = 1

     Case %WM_LButtonDblClk
        'return to DesignMode=1, if necessary     hDlg doubleclick
        If DesignMode = 0 Then     'the overlay is hidden, so the double click comes through
            DesignMode = 1
            DesignModeSettings
        End If

      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'traps Alt-F4, X-button, WindowMenu/Close
             If AutoSaveRestore Then
                 SaveFileName
             End If
         End If

      Case %WM_Destroy
         If AutoCopyCode Then Clipboard Reset : Clipboard Set Text cCode
         Settings_INI "save"
         SetWindowLong hCode, %GWL_WNDPROC, OrigCodeProc   'un-subclass, restore original window procedure for code textbox
         Dialog End hOverlayDlg
         Dialog End hFloatDlg


      Case %WM_Paint
          RefreshDrawing   '1=PB 0=API

      Case %WM_Size
         ResizeWindow

      Case %WM_Move
         Dialog Set Loc hOverlayDlg, 0, yToolbar

      Case %WM_Notify
           If Cb.NmCode = %TTN_GetDispInfo Then
              Local P As TOOLTIPTEXT Ptr
                 P = Cb.LParam
                 Select Case Cb.NmId          'or this:   @P.hdr.idFrom
                    Case %IDM_LeftRight   : @P.@lpszText = "Toggle Toolbar Width"

                    Case %IDM_New         : @P.@lpszText = "New"
                    Case %IDM_Open        : @P.@lpszText = "Open"
                    Case %IDM_Save        : @P.@lpszText = "Save"
                    Case %IDM_SaveAs      : @P.@lpszText = "Save As"

                    Case %IDM_DesignMode  : @P.@lpszText = "Design Mode"
                    Case %IDM_LineMode    : @P.@lpszText = "Line Mode"
                    Case %IDM_DeleteAll   : @P.@lpszText = "Delete All Controls"
                    Case %IDM_Undo        : @P.@lpszText = "Undo (Delete Last Control)"

                    Case %IDM_OpenInIDE   : @P.@lpszText = "Open Code in IDE"
                    Case %IDM_CopyCode    : @P.@lpszText = "Copy Code"
                    Case %IDM_DisplayCodeBox  : @P.@lpszText = "Show CodeBox"
                    Case %IDM_ShowCode    : @P.@lpszText = "Show Code (Notepad)"

                    Case %IDM_Select      : @P.@lpszText = "Select"
                    Case %IDM_Button      : @P.@lpszText = "Button"
                    Case %IDM_Check3State : @P.@lpszText = "Check3State"
                    Case %IDM_CheckBox    : @P.@lpszText = "Checkbox"
                    Case %IDM_ComboBox    : @P.@lpszText = "ComboBox"
                    Case %IDM_Frame       : @P.@lpszText = "Frame"
                    Case %IDM_Graphic     : @P.@lpszText = "Graphic"
                    Case %IDM_Image       : @P.@lpszText = "Image"
                    Case %IDM_ImageX      : @P.@lpszText = "ImageX"
                    Case %IDM_ImgButton   : @P.@lpszText = "ImgButton"
                    Case %IDM_ImgButtonX  : @P.@lpszText = "ImgButtonX"
                    Case %IDM_Label       : @P.@lpszText = "Label"
                    Case %IDM_Line        : @P.@lpszText = "Line"
                    Case %IDM_ListBox     : @P.@lpszText = "ListBox"
                    Case %IDM_ListView    : @P.@lpszText = "Listview"
                    Case %IDM_Option      : @P.@lpszText = "Option"
                    Case %IDM_ProgressBar : @P.@lpszText = "ProgressBar"
                    Case %IDM_HScrollbar  : @P.@lpszText = "HScrollbar"
                    Case %IDM_VScrollbar  : @P.@lpszText = "VScrollbar"
                    Case %IDM_StatusBar   : @P.@lpszText = "StatuBar"
                    Case %IDM_TAB         : @P.@lpszText = "TAB"
                    Case %IDM_TextBox     : @P.@lpszText = "TextBox"
                    Case %IDM_Toolbar     : @P.@lpszText = "Toolbar"
                    Case %IDM_TreeView    : @P.@lpszText = "TreeView"
                 End Select
           End If

      Case %WM_Command
         Select Case Cb.Ctl

            Case %IDM_Debug      :  Debug = Debug Xor 1
                If Debug Then
                    RefreshDrawing : SetFocus hOverlayDlg    'was inactive, now show
                Else
                    FreeConsole : hConsole = 0        'was active, now kill
                    RefreshDrawing : SetFocus hOverlayDlg
                End If
            Case %IDM_ZCommand   :  ? "special command"


            'Toolbar Buttons ==============================================================
            Case %IDM_LeftRight       : ExpandToolbar = ExpandToolbar Xor 1  : ResizeToolbar : DesignModeSettings

            Case 400 To 599
                Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd CurrentControlType, %TBState_Enabled
                Toolbar Set State hFloatDlg, %IDC_ToolbarC, ByCmd CurrentControlType, %TBState_Enabled
                ReSetContextControlMenu

                CurrentControlType = Cb.Ctl
                Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd CurrentControlType, %TBState_Enabled Or %TBState_Checked
                Toolbar Set State hFloatDlg, %IDC_ToolbarC, ByCmd CurrentControlType, %TBState_Enabled Or %TBState_Checked
                Menu Set State hDialogContext, ByCmd CurrentControlType, 8

            'Main Context Menu  ==============================================================
            Case %IDM_Undo             : Undo

            'Action Context Menu  ==============================================================
            Case %IDM_SelectAll        : SelectAll
            Case %IDM_UnSelectAll      : UnSelectAll

            Case %IDM_DeleteSelected   : DeleteSelectedControls
            Case %IDM_DeleteAll
               If ConfirmDeleteAll And UBound(cList)>0 And MsgBox("Delete All Controls?", %MB_OkCancel + %MB_IconQuestion, "Delete All Controls") = %IdOk Then DeleteAllControls

            Case %IDM_ShowCode
                If Len(Trim$(cCode, Any " " + $CrLf)) = 0 Then cCode = "<< empty >>"
                Open EXE.Path$ + "gbDesigner_temp.txt" For Output As #1
                Print #1, cCode
                Close #1
                iReturn = Shell("notepad.exe " + EXE.Path$ + "gbDesigner_temp.txt", 1)    'does not wait
            Case %IDM_CopyCode         : Clipboard Reset : Clipboard Set Text cCode
            Case %IDM_DialogCapture    : Sleep 450 : keybd_event(%VK_SnapShot, 1, 0, 0)  'place active dialog on clipboard

            Case %IDM_New              : NewDesign
            Case %IDM_Open             : SelectFileToOpen
            Case %IDM_Save             : SaveFileName
            Case %IDM_SaveAs           : SaveFileAs
            Case %IDM_Restore          : OpenCFN(1,1)

            Case %IDM_SetGridSize           : SetGridSize         : RefreshDrawing
            Case %IDM_SetDisplayGridSize    : SetDisplayGridSize  : RefreshDrawing
            Case %IDM_SetTabOrder           : DisplayOrderDialog
            Case %IDM_AlignAllToGrid        : AlignAllToGrid

            'Settings Context Menu  ==============================================================
            Case %IDM_DesignMode        : DesignMode = DesignMode Xor 1         : DesignModeSettings : Dialog ReDraw hDlg
            Case %IDM_LineMode          : LineMode = LineMode Xor 1             : DesignModeSettings
            Case %IDM_DisplayToolbar    : DisplayToolbar = DisplayToolbar Xor 1 : DesignModeSettings
            Case %IDM_DisplayCodeBox
                'anti-flickering
                Control Set Loc hDlg, %IDC_CodeBox, 0, +5000
                Control Show State hDlg, %IDC_CodeBox, %SW_Hide
                Dialog ReDraw hDlg
                If DisplayCodeBox = 0 Then yCodeBox = 0
                'resize dialog for new state (codebox on/off)
                Control Get Size hDlg, %IDC_CodeBox To w,iReturn : Dialog Get Size hDlg To w,h
                Dialog Set Size hDlg, w,h + IIf(DisplayCodeBox, -iReturn, iReturn)
                'finish
                DisplayCodeBox = DisplayCodeBox Xor 1 : DesignModeSettings : CreateCode


            Case %IDM_SnapToGrid
                SnapToGrid = SnapToGrid Xor 1
                Menu Set State hDialogContext, ByCmd %IDM_SnapToGrid, SnapToGrid * 8
            Case %IDM_ShowGrid
                ShowGrid = ShowGrid Xor 1
                Menu Set State hSettings, ByCmd %IDM_ShowGrid, ShowGrid * 8
                RefreshDrawing

            Case %IDM_ConfirmDeleteAll
                ConfirmDeleteAll = ConfirmDeleteAll Xor 1
                Menu Set State hSettings, ByCmd %IDM_ConfirmDeleteAll, ConfirmDeleteAll* 8
            Case %IDM_AutoSaveRestore
                AutoSaveRestore = AutoSaveRestore Xor 1
                Menu Set State hSettings, ByCmd %IDM_AutoSaveRestore, AutoSaveRestore * 8

            Case %IDM_FloatingToolbar : FloatingToolbar = FloatingToolbar Xor 1 : DesignModeSettings
            Case %IDM_LineModeLabels
                LineModeLabels = LineModeLabels Xor 1 : RefreshDrawing
                Menu Set State hSettings, ByCmd %IDM_LineModeLabels, LineModeLabels* 8
            Case %IDM_NumericLabels
                NumericLabels = NumericLabels Xor 1
                Menu Set State hSettings, ByCmd %IDM_NumericLabels, NumericLabels * 8

            Case %IDM_UseExpandedCode
                UseExpandedCode = UseExpandedCode Xor 1
                Menu Set State hSettings, ByCmd %IDM_UseExpandedCode, UseExpandedCode * 8
                CreateCode
            Case %IDM_SDKCode
                SDKCode = SDKCode Xor 1
                Menu Set State hSettings, ByCmd %IDM_SDKCode, SDKCode * 8
                CreateCode
            Case %IDM_AutoCopyCode  : AutoCopyCode = AutoCopyCode Xor 1


            'CodeBox Context Menu  ==============================================================
            Case %IDM_CodeDelete  : SendMessage hCode, %WM_CLEAR, 0, 0
            Case %IDM_CodeCut     : SendMessage hCode, %WM_CUT, 0, 0
            Case %IDM_CodeCopy    : SendMessage hCode, %WM_COPY, 0, 0
            Case %IDM_CodeCopyAll : CodeCopyAll
            Case %IDM_CodePaste   : SendMessage hCode, %WM_PASTE, 0, 0
            Case %IDM_OpenInIDE   : OpenInIDE

            'Control Context Menu  ==============================================================
            Case %IDM_ControlDelete : DeleteContextControl
            Case %IDM_Properties    : DisplayPropertyDialog

         End Select
   End Select
End Function

Sub Settings_INI(Task$)
   DebugLog("Settings")
   Local x, y As Long
   Local xResult, yResult, tempAsciiZ As Asciiz * %Max_Path
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "700", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get string variables
      Getprivateprofilestring "All", "CFN", "", tempAsciiZ, %Max_Path, INIFileName
      CFN = tempAsciiZ

      'get numeric variables
      Getprivateprofilestring "All", "NumericLabels", "0", tempAsciiZ, %Max_Path, INIFileName
      NumericLabels = Val(tempAsciiZ)

      Getprivateprofilestring "All", "Debug", "0", tempAsciiZ, %Max_Path, INIFileName
      Debug = Val(tempAsciiZ)

      Getprivateprofilestring "All", "dFlag", "0", tempAsciiZ, %Max_Path, INIFileName
      dFlag = Val(tempAsciiZ)

      Getprivateprofilestring "All", "AutoCopyCode", "1", tempAsciiZ, %Max_Path, INIFileName
      AutoCopyCode = Val(tempAsciiZ)

      Getprivateprofilestring "All", "LineModeLabels", "0", tempAsciiZ, %Max_Path, INIFileName
      LineModeLabels = Val(tempAsciiZ)

      Getprivateprofilestring "All", "LineMode", "0", tempAsciiZ, %Max_Path, INIFileName
      LineMode = Val(tempAsciiZ)

      Getprivateprofilestring "All", "ExpandToolbar", "0", tempAsciiZ, %Max_Path, INIFileName
      ExpandToolbar = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FLeft", "100", tempAsciiZ, %Max_Path, INIFileName
      FLeft = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FTop", "100", tempAsciiZ, %Max_Path, INIFileName
      FTop = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FWidth", "125", tempAsciiZ, %Max_Path, INIFileName
      FWidth = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FHeight", "250", tempAsciiZ, %Max_Path, INIFileName
      FHeight = Val(tempAsciiZ)

      Getprivateprofilestring "All", "yCodeBox", "200", tempAsciiZ, %Max_Path, INIFileName
      yCodeBox = Val(tempAsciiZ)

      'get numeric variables
      Getprivateprofilestring "All", "BaseID", "5000", tempAsciiZ, %Max_Path, INIFileName
      BaseID = Val(tempAsciiZ)

      Getprivateprofilestring "All", "CurrentControlType", "401", tempAsciiZ, %Max_Path, INIFileName
      CurrentControlType = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DisplayToolbar", "0", tempAsciiZ, %Max_Path, INIFileName
      DisplayToolbar = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DisplayCodeBox", "0", tempAsciiZ, %Max_Path, INIFileName
      DisplayCodeBox = Val(tempAsciiZ)

      Getprivateprofilestring "All", "GridSize", "25", tempAsciiZ, %Max_Path, INIFileName
      GridSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DisplayGridSize", "25", tempAsciiZ, %Max_Path, INIFileName
      DisplayGridSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "SnapToGrid", "1", tempAsciiZ, %Max_Path, INIFileName
      SnapToGrid = Val(tempAsciiZ)

      Getprivateprofilestring "All", "ShowGrid", "1", tempAsciiZ, %Max_Path, INIFileName
      ShowGrid = Val(tempAsciiZ)

      Getprivateprofilestring "All", "SelectBoxSize", "10", tempAsciiZ, %Max_Path, INIFileName
      SelectBoxSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "AutoSaveRestore", "1", tempAsciiZ, %Max_Path, INIFileName
      AutoSaveRestore = Val(tempAsciiZ)

      Getprivateprofilestring "All", "UseExpandedCode", "1", tempAsciiZ, %Max_Path, INIFileName
      UseExpandedCode = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FloatingToolbar", "0", tempAsciiZ, %Max_Path, INIFileName
      FloatingToolbar = Val(tempAsciiZ)

      Getprivateprofilestring "All", "ConfirmDeleteAll", "1", tempAsciiZ, %Max_Path, INIFileName
      ConfirmDeleteAll = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DesignMode", "1", tempAsciiZ, %Max_Path, INIFileName
      DesignMode = Val(tempAsciiZ)

      Getprivateprofilestring "All", "SDKCode", "0", tempAsciiZ, %Max_Path, INIFileName
      SDKCode = Val(tempAsciiZ)

      Menu Set State hDialogContext, ByCmd CurrentControlType, 8

      Menu Set State hSettings, ByCmd %IDM_DesignMode, DesignMode * 8
      Menu Set State hSettings, ByCmd %IDM_LineMode, LineMode * 8
      Menu Set State hSettings, ByCmd %IDM_DisplayToolbar, DisplayToolbar * 8
      Menu Set State hSettings, ByCmd %IDM_DisplayCodeBox, DisplayCodeBox * 8
      Menu Set State hSettings, ByCmd %IDM_SnapToGrid, SnapToGrid * 8
      Menu Set State hSettings, ByCmd %IDM_ShowGrid, ShowGrid * 8
      Menu Set State hSettings, ByCmd %IDM_ConfirmDeleteAll, ConfirmDeleteAll * 8
      Menu Set State hSettings, ByCmd %IDM_AutoSaveRestore, AutoSaveRestore * 8
      Menu Set State hSettings, ByCmd %IDM_UseExpandedCode, UseExpandedCode * 8
      Menu Set State hSettings, ByCmd %IDM_FloatingToolbar, FloatingToolbar * 8
      Menu Set State hSettings, ByCmd %IDM_SDKCode, SDKCode * 8
      Menu Set State hSettings, ByCmd %IDM_AutoCopyCode, AutoCopyCode * 8
      Menu Set State hSettings, ByCmd %IDM_LineModeLabels, LineModeLabels * 8
      Menu Set State hSettings, ByCmd %IDM_NumericLabels, NumericLabels * 8

      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd CurrentControlType, %TBState_Enabled Or %TBState_Checked
      Toolbar Set State hDlg, %IDC_ToolbarA, %IDM_DisplayCodeBox, %TBState_Enabled Or %TBState_Checked

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      tempASCIIZ = CFN
      WritePrivateProfileString "All", "CFN", tempASCIIZ, INIFileName

      'save numeric variables
      tempASCIIZ = Str$(NumericLabels)
      WritePrivateProfileString "All", "NumericLabels", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(Debug)
      WritePrivateProfileString "All", "Debug", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(Debug)
      WritePrivateProfileString "All", "Debug", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(dFlag)
      WritePrivateProfileString "All", "dFlag", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(AutoCopyCode)
      WritePrivateProfileString "All", "AutoCopyCode", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(LineModeLabels)
      WritePrivateProfileString "All", "LineModeLabels", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(LineMode)
      WritePrivateProfileString "All", "LineMode", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(ExpandToolbar)
      WritePrivateProfileString "All", "ExpandToolbar", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(yCodeBox)
      WritePrivateProfileString "All", "yCodeBox", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(BaseID)
      WritePrivateProfileString "All", "BaseID", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(CurrentControlType)
      WritePrivateProfileString "All", "CurrentControlType", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DisplayToolbar)
      WritePrivateProfileString "All", "DisplayToolbar", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DisplayCodeBox)
      WritePrivateProfileString "All", "DisplayCodeBox", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(GridSize)
      WritePrivateProfileString "All", "GridSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DisplayGridSize)
      WritePrivateProfileString "All", "DisplayGridSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(SnapToGrid)
      WritePrivateProfileString "All", "SnapToGrid", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(ShowGrid)
      WritePrivateProfileString "All", "ShowGrid", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(SelectBoxSize)
      WritePrivateProfileString "All", "SelectBoxSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(AutoSaveRestore)
      WritePrivateProfileString "All", "AutoSaveRestore", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(UseExpandedCode)
      WritePrivateProfileString "All", "UseExpandedCode", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(FloatingToolbar)
      WritePrivateProfileString "All", "FloatingToolbar", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(ConfirmDeleteAll)
      WritePrivateProfileString "All", "ConfirmDeleteAll", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DesignMode)
      WritePrivateProfileString "All", "DesignMode", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(SDKCode)
      WritePrivateProfileString "All", "SDKCode", tempASCIIZ, INIFileName

   End If
End Sub

Sub CreateContextMenu
    DebugLog("CreateContextMenu")

     'code textbox context menu
     Menu New PopUp To hCodeContext
     Menu Add String, hCodeContext, "Delete", %IDM_CodeDelete, %MF_Enabled
     Menu Add String, hCodeContext, "Cut", %IDM_CodeCut, %MF_Enabled
     Menu Add String, hCodeContext, "Copy", %IDM_CodeCopy, %MF_Enabled
     Menu Add String, hCodeContext, "Copy All", %IDM_CodeCopyAll, %MF_Enabled
     Menu Add String, hCodeContext, "Paste", %IDM_CodePaste, %MF_Enabled
     Menu Add String, hCodeContext, "-", %IDM_Sep, 0
     Menu Add String, hCodeContext, "Open Code in IDE", %IDM_OpenInIDE, %MF_Enabled

     Menu New PopUp To hActions
     Menu Add String, hActions, "Select All", %IDM_SelectAll, %MF_Enabled
     Menu Add String, hActions, "UnSelect All", %IDM_UnSelectAll, %MF_Enabled
     Menu Add String, hActions, "-", %IDM_Sep, 0
     Menu Add String, hActions, "Delete Selected Controls", %IDM_DeleteSelected,  %MF_Enabled
     Menu Add String, hActions, "Delete All Controls", %IDM_DeleteAll, %MF_Enabled
     Menu Add String, hActions, "-", %IDM_Sep, 0
     Menu Add String, hActions, "Open Code in IDE", %IDM_OpenInIDE,  %MF_Enabled
     Menu Add String, hActions, "Copy Code", %IDM_CopyCode,  %MF_Enabled
     Menu Add String, hActions, "Show Code (Notepad)", %IDM_ShowCode,  %MF_Enabled
     Menu Add String, hActions, "Capture Dialog", %IDM_DialogCapture, %MF_Enabled
     Menu Add String, hActions, "-", %IDM_Sep, 0
     Menu Add String, hActions, "New", %IDM_New, %MF_Enabled
     Menu Add String, hActions, "Open", %IDM_Open, %MF_Enabled
     Menu Add String, hActions, "Save", %IDM_Save, %MF_Enabled
     Menu Add String, hActions, "SaveAs", %IDM_SaveAs, %MF_Enabled
     Menu Add String, hActions, "Restore", %IDM_Restore, %MF_Enabled
     Menu Add String, hActions, "-", %IDM_Sep, 0
     Menu Add String, hActions, "Set Snap Grid Size", %IDM_SetGridSize,  %MF_Enabled
     Menu Add String, hActions, "Set Display Grid Size", %IDM_SetDisplayGridSize,  %MF_Enabled
     Menu Add String, hActions, "Set Tab Order", %IDM_SetTabOrder,  %MF_Enabled
     Menu Add String, hActions, "One Time Grid Alignment", %IDM_AlignAllToGrid,  %MF_Enabled
     Menu Add String, hActions, "-", %IDM_Sep, 0
     Menu Add String, hActions, "Online Help", %IDM_WebSite, %MF_Enabled

     Menu New PopUp To hSettings
     Menu Add String, hSettings, "Enable Design Mode", %IDM_DesignMode,  %MF_Enabled
     Menu Add String, hSettings, "Enable Line Mode", %IDM_LineMode,  %MF_Enabled
     Menu Add String, hSettings, "Display Toolbar", %IDM_DisplayToolbar,  %MF_Enabled
     Menu Add String, hSettings, "Display Code Box", %IDM_DisplayCodeBox,  %MF_Enabled
     Menu Add String, hSettings, "-", %IDM_Sep, 0
     Menu Add String, hSettings, "Snap To Grid", %IDM_SnapToGrid,  %MF_Enabled
     Menu Add String, hSettings, "Show Grid", %IDM_ShowGrid,  %MF_Enabled
     Menu Add String, hSettings, "-", %IDM_Sep, 0
     Menu Add String, hSettings, "Confirm Delete All", %IDM_ConfirmDeleteAll,  %MF_Enabled
     Menu Add String, hSettings, "Auto Save/Restore", %IDM_AutoSaveRestore,  %MF_Enabled
     Menu Add String, hSettings, "-", %IDM_Sep, 0
     Menu Add String, hSettings, "Floating Toolbar", %IDM_FloatingToolbar,  %MF_Enabled
     Menu Add String, hSettings, "Line Mode Labels", %IDM_LineModeLabels,  %MF_Enabled
     Menu Add String, hSettings, "Numeric Control Labels", %IDM_NumericLabels,  %MF_Enabled
     Menu Add String, hSettings, "-", %IDM_Sep, 0
     Menu Add String, hSettings, "Use Expanded Code", %IDM_UseExpandedCode,  %MF_Enabled
     Menu Add String, hSettings, "SDK Code", %IDM_SDKCode,  %MF_Enabled
     Menu Add String, hSettings, "AutoCopy Code on Exit", %IDM_AutoCopyCode,  %MF_Enabled


     'control context menu
     Menu New PopUp To hControlContext
     Menu Add String, hControlContext, "Delete Current", %IDM_ControlDelete, %MF_Enabled
     Menu Add String, hControlContext, "Delete All Selected", %IDM_DeleteSelected, %MF_Enabled
     Menu Add String, hControlContext, "-", %IDM_Sep, 0
     Menu Add String, hControlContext, "Properties", %IDM_Properties, %MF_Enabled

     'dialog context menu
     Menu New PopUp To hDialogContext
     Menu Add PopUp,  hDialogContext, "Actions", hActions, %MF_Enabled
     Menu Add PopUp,  hDialogContext, "Settings", hSettings, %MF_Enabled
     Menu Add String, hDialogContext, "-", %IDM_Sep, 0
     Menu Add String, hDialogContext, "Undo (Delete Last Control)", %IDM_Undo, %MF_Enabled
     Menu Add String, hDialogContext, "-", %IDM_Sep, 0

     Menu Add String, hDialogContext, "Select Mode", %IDM_Select, %MF_Enabled
     Menu Add String, hDialogContext, "Button", %IDM_Button, %MF_Enabled
     Menu Add String, hDialogContext, "Check3State", %IDM_Check3State, %MF_Enabled
     Menu Add String, hDialogContext, "CheckBox", %IDM_CheckBox, %MF_Enabled
     Menu Add String, hDialogContext, "ComboBox", %IDM_ComboBox, %MF_Enabled
     Menu Add String, hDialogContext, "Frame", %IDM_Frame, %MF_Enabled
     Menu Add String, hDialogContext, "Graphic", %IDM_Graphic, %MF_Enabled
     Menu Add String, hDialogContext, "Image", %IDM_Image, %MF_Enabled
     Menu Add String, hDialogContext, "ImageX", %IDM_ImageX, %MF_Enabled
     Menu Add String, hDialogContext, "ImgButton", %IDM_ImgButton, %MF_Enabled
     Menu Add String, hDialogContext, "ImgButtonX", %IDM_ImgButtonX, %MF_Enabled
     Menu Add String, hDialogContext, "Label", %IDM_Label, %MF_Enabled
     Menu Add String, hDialogContext, "Line", %IDM_Line, %MF_Enabled
     Menu Add String, hDialogContext, "ListBox", %IDM_ListBox, %MF_Enabled
     Menu Add String, hDialogContext, "ListView", %IDM_ListView, %MF_Enabled
     Menu Add String, hDialogContext, "Option", %IDM_Option, %MF_Enabled
     Menu Add String, hDialogContext, "ProgressBar", %IDM_ProgressBar, %MF_Enabled
     Menu Add String, hDialogContext, "HScrollbar", %IDM_HScrollBar, %MF_Enabled
     Menu Add String, hDialogContext, "VScrollbar", %IDM_VScrollBar, %MF_Enabled
     Menu Add String, hDialogContext, "StatusBar", %IDM_StatusBar, %MF_Enabled
     Menu Add String, hDialogContext, "TAB", %IDM_Tab, %MF_Enabled
     Menu Add String, hDialogContext, "TextBox", %IDM_TextBox, %MF_Enabled
     Menu Add String, hDialogContext, "Toolbar", %IDM_Toolbar, %MF_Enabled
     Menu Add String, hDialogContext, "TreeView", %IDM_TreeView, %MF_Enabled

End Sub

Sub DeleteContextControl
    DebugLog("DeleteContextControl")
    If ContextControl = 0 Then Exit Sub
    Control Kill hDlg, cList(ContextControl).cID  'remove the control
    Array Delete cList(ContextControl)            'remove array element
    ReDim Preserve cList(UBound(cList)-1)
    CreateCode
    RefreshDrawing
    DisplayCaption
End Sub

Sub DeleteSelectedControls
    DebugLog("DeleteSelectedControls")
    Local i, iCount As Long
    For i = UBound(cList) To 1 Step -1
        If cList(i).sel Then
           Incr iCount
           Control Kill hDlg, cList(i).cID  'remove the control
           Array Delete cList(i)            'remove array element
        End If
    Next i
    ReDim Preserve cList(UBound(cList)-iCount)
    CreateCode
    RefreshDrawing
    DisplayCaption
End Sub

Sub SaveFileName
    DebugLog("SaveFileName")
    Local iCount As Long
    iCount = UBound(cList)
    If IsFile(CFN) Then Kill CFN
    Open CFN For Binary As #1
    Put #1, 1, iCount
    Put #1, , cList()
    Close #1
End Sub

Sub OpenCFN(iFlag As Long, fFlag As Long)  '1-clear drawing  0-not clear drawing : fFlag=1 use MsgBox NOT FOUND
    DebugLog("OpenCFN")
    Local iCount As Long
    If IsFile(CFN) Then
       If iFlag Then DeleteAllControls
       Open CFN For Binary As #1
       Get #1, 1, iCount
       ReDim cList(iCount)
       Get #1, , cList()
       Close #1
       For iCount = 1 To UBound(cList)
          AddNewControl iCount, 1   '1=new cID 0=same cID
       Next i
       CreateCode
       RefreshDrawing
       DisplayCaption
    Else
       If fFlag Then
           MsgBox "File not found!   " + CFN, %MB_Ok + %MB_IconInformation, "Open Design"
       End If
    End If
End Sub

Sub DisplayCaption
'    DebugLog("DisplayCaption")
    Local SB As String
    SB = ControlNames(CurrentControlType)
    If DesignMode Then
       Dialog Set Text hDlg, "gbDesigner   " + PathName$(Namex,CFN) + "   " + "Design Mode: " +  SB + "   " + "Controls:" + Str$(UBound(cList)) + "  " + SA + "    " + SC
    Else
       Dialog Set Text hDlg, "gbDesigner v1.0  Written by Gary Beene in PowerBASIC"
    End If
End Sub

Sub SelectAll
    DebugLog("SelectAll")
    Local i As Long
    For i = 1 To UBound(cList)
        cList(i).sel = 1
    Next i
    RefreshDrawing
End Sub

Sub UnSelectAll
    DebugLog("UnSelectAll")
    Local i As Long
    For i = 1 To UBound(cList)
        cList(i).sel = 0
    Next i
    RefreshDrawing
End Sub

Sub ResetContextControlMenu
    DebugLog("ResetContextControlMenu")
    Local i As Long
    For i = 400 To 599
       Menu Set State hDialogContext, ByCmd i, 0
    Next i
End Sub

Sub CreateCodeBox
    DebugLog("CreateCodeBox")
   Local w,Style As Long
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll Or %WS_HScroll _
             Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop Or %WS_Border
    Control Add TextBox, hDlg, %IDC_CodeBox, "<< generated source code >>", 0, 0, 0, 200, Style
    Control Get Size hDlg, %IDC_CodeBox To w,yCodeBox
    Control Handle hDlg, %IDC_CodeBox To hCode
    OrigCodeProc = SetWindowLong(GetDlgItem(hDlg, %IDC_CodeBox), %GWL_WndProc, CodePtr(NewCodeProc))   'subclass a control
   Font New "Courier new", 10, 0 To hFont
   Control Set Font hDlg, %IDC_CodeBox, hFont
End Sub

Function NewCodeProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Word,lParam) : y = Hi(Word, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hCodeContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OrigCodeProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateFloatingToolbars
    DebugLog("CreateFloatingToolbars")
    Local hTips As Dword
    'ToolbarB - functions
    Control Add Toolbar, hFloatDlg, %IDC_ToolbarB,"", 0,0,0,0, %TbStyle_Tooltips Or %WS_Border Or %WS_Child Or %TbStyle_Flat
    Toolbar Set ImageList hFloatDlg, %IDC_ToolbarB, hImageList, 0    'attach imagelist
    hTips = SendMessage(GetDlgItem(hFloatDlg, %IDC_ToolbarB), %TB_GETTOOLTIPS, 0, 0)
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 26, %IDM_New,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 30, %IDM_Open,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 32, %IDM_Save,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 31, %IDM_SaveAs,   %TbStyle_Button, ""

    Toolbar Set State   hFloatDlg, %IDC_ToolbarB, 4, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 28, %IDM_DesignMode,   %TbStyle_Check, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 36, %IDM_LineMode,   %TbStyle_Check, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 33, %IDM_DeleteAll,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 27, %IDM_Undo,   %TbStyle_Button, ""

    Toolbar Set State   hFloatDlg, %IDC_ToolbarB, 8, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 41, %IDM_OpenInIDE,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 24, %IDM_CopyCode,   %TbStyle_Button, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 34, %IDM_DisplayCodeBox,   %TbStyle_Check, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarB, 38, %IDM_ShowCode,   %TbStyle_Button, ""

    'ToolbarC - controls
    Control Add Toolbar, hFloatDlg, %IDC_ToolbarC,"", 0,97,0,0, %CCS_NoMoveY Or %TbStyle_Tooltips Or %WS_Border Or %WS_Child Or %TbStyle_Flat
    Toolbar Set ImageList hFloatDlg, %IDC_ToolbarC, hImageList, 0    'attach imagelist
    hTips = SendMessage(GetDlgItem(hFloatDlg, %IDC_ToolbarC), %TB_GETTOOLTIPS, 0, 0)
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP


    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 29, %IDM_Select,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 1, %IDM_Button,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 40, %IDM_Check3State,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 2, %IDM_CheckBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 3, %IDM_ComboBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, 4, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 4, %IDM_Frame,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 5, %IDM_Graphic,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 6, %IDM_Image,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 7, %IDM_ImageX,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, 8, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 8, %IDM_ImgButton,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 9, %IDM_ImgButtonX,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 10, %IDM_Label,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 11, %IDM_Line,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, 12, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 12, %IDM_ListBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 13, %IDM_ListView,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 14, %IDM_Option,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 15, %IDM_ProgressBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, 16, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 16, %IDM_HScrollBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 17, %IDM_VScrollBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 19, %IDM_StatusBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, 20, %TBState_Enabled Or %TBState_Wrap

    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 20, %IDM_Tab,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 21, %IDM_TextBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 22, %IDM_Toolbar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hFloatDlg, %IDC_ToolbarC, 23, %IDM_TreeView,   %TbStyle_Check Or %TbStyle_Group, ""
End Sub

Sub CreateMainToolbar
    DebugLog("CreateMainToolbar")
    Local w, hTips As Dword
    Control Add Toolbar, hDlg, %IDC_ToolbarA,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Border Or %WS_Child
    Control Get Size hDlg, %IDC_ToolbarA To w,yToolbar
    hTips = SendMessage(GetDlgItem(hDlg, %IDC_ToolbarA), %TB_GETTOOLTIPS, 0, 0)
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP


    Toolbar Set ImageList hDlg, %IDC_ToolbarA, hImageList, 0    'attach imagelist

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 35, %IDM_LeftRight,  %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 26, %IDM_New,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 30, %IDM_Open,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 32, %IDM_Save,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 31, %IDM_SaveAs,   %TbStyle_Button, ""
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 28, %IDM_DesignMode,   %TbStyle_Check, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 36, %IDM_LineMode,   %TbStyle_Check, ""
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20


    Toolbar Add Button  hDlg, %IDC_ToolbarA, 33, %IDM_DeleteAll,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 27, %IDM_Undo,   %TbStyle_Button, ""
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 41, %IDM_OpenInIDE,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 24, %IDM_CopyCode,   %TbStyle_Button, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 34, %IDM_DisplayCodeBox,   %TbStyle_Check, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 38, %IDM_ShowCode,   %TbStyle_Button, ""
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 29, %IDM_Select,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 1, %IDM_Button,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA,40, %IDM_Check3State,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 2, %IDM_CheckBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 3, %IDM_ComboBox,   %TbStyle_Check Or %TbStyle_Group, ""

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 4, %IDM_Frame,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 5, %IDM_Graphic,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 6, %IDM_Image,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 7, %IDM_ImageX,   %TbStyle_Check Or %TbStyle_Group, ""

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 8, %IDM_ImgButton,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 9, %IDM_ImgButtonX,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 10, %IDM_Label,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 11, %IDM_Line,   %TbStyle_Check Or %TbStyle_Group, ""

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 12, %IDM_ListBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 13, %IDM_ListView,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 14, %IDM_Option,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 15, %IDM_ProgressBar,   %TbStyle_Check Or %TbStyle_Group, ""

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 16, %IDM_HScrollBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 17, %IDM_VScrollBar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 19, %IDM_StatusBar,   %TbStyle_Check Or %TbStyle_Group, ""

    Toolbar Add Button  hDlg, %IDC_ToolbarA, 20, %IDM_Tab,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 21, %IDM_TextBox,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 22, %IDM_Toolbar,   %TbStyle_Check Or %TbStyle_Group, ""
    Toolbar Add Button  hDlg, %IDC_ToolbarA, 23, %IDM_TreeView,   %TbStyle_Check Or %TbStyle_Group, ""
End Sub

Sub ResizeWindow
   DebugLog("ResizeWindow")
   Local h As Long, w As Long
   Dialog Get Client hDlg To w,h

   'resize overlayDlg
   Dialog Set Loc hOverlayDlg, 0, yToolbar
   Dialog Set Size hOverlayDlg, w,h - yToolbar - yCodeBox

   'resize CodeBox
   If DesignMode And DisplayCodeBox Then
      Control Set Loc  hDlg, %IDC_CodeBox, 0, h-yCodeBox
      Control Set Size hDlg, %IDC_CodeBox, w, yCodeBox
   End If
End Sub

Function IsMouseOverControl() As Long
    DebugLog("IsMouseOverControl")
    Local i As Long
    For i = UBound(cList) To 1 Step -1
        Function = 0
        If truept.x < cList(i).x1 Or truept.x > cList(i).x2 Or truept.y < cList(i).y1 Or truept.y > cList(i).y2 Then Iterate For
        Function = i
        Exit Function
    Next i
End Function

Function IsMouseOverSelectBox() As Long
    DebugLog("IsMouseOverSelectBox")
    '1--2   corner positions
    '4--3
    Local i As Long
    For i = 1 To UBound(cList)
        Function = 0
        If cList(i).sel Then
            'upper left
            If truept.x > (cList(i).x1 - SelectBoxSize) And _
               truept.x < cList(i).x1 And _
               (truept.y - yToolbar) > (cList(i).y1 - SelectBoxSize - yToolbar) And _
               (truept.y - yToolbar) < (cList(i).y1 - yToolbar) Then ctlCorner = 1 : Function = i : Exit Function
            'upper right
            If truept.x > cList(i).x2 And _
               truept.x < (cList(i).x2 + SelectBoxSize) And _
               (truept.y - yToolbar) > (cList(i).y1 - SelectBoxSize - yToolbar) And _
               (truept.y - yToolbar) < (cList(i).y1 - yToolbar) Then ctlCorner = 2 : Function = i : Exit Function
            'lower right
            If truept.x > cList(i).x2 And _
               truept.x < (cList(i).x2 + SelectBoxSize) And _
               (truept.y - yToolbar) > (cList(i).y2 - yToolbar) And _
               (truept.y - yToolbar) < (cList(i).y2 + SelectBoxSize - yToolbar) Then ctlCorner = 3 : Function = i : Exit Function
            'lower left
            If truept.x > (cList(i).x1 - SelectBoxSize) And _
               truept.x < cList(i).x1 And _
               (truept.y - yToolbar) > (cList(i).y2 - yToolbar) And _
               (truept.y - yToolbar) < (cList(i).y2 + SelectBoxSize - yToolbar) Then ctlCorner = 4 : Function = i : Exit Function
        End If
    Next i
End Function

Sub BuildAcceleratorTable
    DebugLog("BuildAcceleratorTable")
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Left  : ac(c).cmd   = %IDM_Left           : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Right : ac(c).cmd   = %IDM_Right          : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Up    : ac(c).cmd   = %IDM_Up             : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Down  : ac(c).cmd   = %IDM_Down           : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Tab   : ac(c).cmd   = %IDM_TabKey         : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Delete: ac(c).cmd   = %IDM_DeleteSelected : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E     : ac(c).cmd   = %IDM_UseExpandedCode: Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D     : ac(c).cmd   = %IDM_Debug          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z     : ac(c).cmd   = %IDM_ZCommand       : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub MoveAllControls(iFlag As Long)  '1-left 2-right 3-up 4-down
    DebugLog("MoveAllControls")
    Local i As Long
    For i = 1 To UBound(cList)
        If cList(i).sel Then
            Select Case iFlag
               Case 1  'left
                   cList(i).x1 = cList(i).x1 - GridSize
                   cList(i).x2 = cList(i).x2 - GridSize
                   Control Set Loc hDlg, cList(i).cID, cList(i).x1, cList(i).y1
               Case 2  'right
                   cList(i).x1 = cList(i).x1 + GridSize
                   cList(i).x2 = cList(i).x2 + GridSize
                   Control Set Loc hDlg, cList(i).cID, cList(i).x1, cList(i).y1
               Case 3  'up
                   cList(i).y1 = cList(i).y1 - GridSize
                   cList(i).y2 = cList(i).y2 - GridSize
                   Control Set Loc hDlg, cList(i).cID, cList(i).x1, cList(i).y1
               Case 4  'down
                   cList(i).y1 = cList(i).y1 + GridSize
                   cList(i).y2 = cList(i).y2 + GridSize
                   Control Set Loc hDlg, cList(i).cID, cList(i).x1, cList(i).y1
            End Select
        End If
    Next i
    CreateCode
    RefreshDrawing
End Sub

Sub CodeCopyAll
    DebugLog("CopyAll")
    Local temp$
    Control Get Text hDlg, %IDC_CodeBox To temp$
    Clipboard Reset
    Clipboard Set Text temp$
End Sub

Sub Undo
    DebugLog("Undo")
    Local i As Long
    i = UBound(cList)
    If i = 0 Then Exit Sub
    Control Kill hDlg, cList(i).cID
    ReDim Preserve cList(i-1)
    CreateCode
    RefreshDrawing
    DisplayCaption
End Sub

Sub AdjustPTToGrid
'    DebugLog("AdjustPTtoGrid")
    Local d As Single
    d = GridSize \ 2
'    pt.x = (pt.x \ GridSize) * GridSize : pt.y = (pt.y \ GridSize) * GridSize  'truncates, not rounds up/down
    pt.x = ((pt.x+d) \ GridSize) * GridSize : pt.y = ((pt.y+d) \ GridSize) * GridSize  'not rounds up/down
End Sub

Sub AlignAllToGrid
    DebugLog("AlignAllToGrid")
   Local i As Long, d As Single
    d = GridSize \ 2
   For i = 1 To UBound(cList)
      cList(i).x1 = ((cList(i).x1+d) \ GridSize) * GridSize
      cList(i).y1 = ((cList(i).y1+d) \ GridSize) * GridSize
      cList(i).x2 = ((cList(i).x2+d) \ GridSize) * GridSize
      cList(i).y2 = ((cList(i).y2+d) \ GridSize) * GridSize
      If cList(i).x2 <= cList(i).x1 Then cList(i).x2 = cList(i).x1 + GridSize
      If cList(i).y2 <= cList(i).y1 Then cList(i).y2 = cList(i).y1 + GridSize
      Control Set Loc hDlg, cList(i).cID, cList(i).x1, cList(i).y1
      Control Set Size hDlg, cList(i).cId, cList(i).x2 - cList(i).x1, cList(i).y2 - cList(i).y1
   Next i
   RefreshDrawing
End Sub

Sub SetGridSize
    DebugLog("SetGridSize")
   Local temp$
   temp$ = InputBox$("Enter Snap Grid Size: ", "Set User String", Str$(GridSize), 200,250)
   If Val(temp$)< 1 Then  Exit Sub   'no change
   GridSize = Val(temp$)
End Sub

Sub SetDisplayGridSize
    DebugLog("SetDisplayGridSize")
   Local temp$
   temp$ = InputBox$("Enter Display Grid Size: ", "Set User String", Str$(DisplayGridSize), 200,250)
   If Val(temp$)< 1 Then  Exit Sub   'no change
   DisplayGridSize = Val(temp$)
End Sub

Sub RespondToTABKey
    DebugLog("RespondToTabKey")
    'move to next control and select it
    UnSelectAll
    Incr CurrentControl
    If CurrentControl > UBound(cList) Then CurrentControl = 1
    cList(CurrentControl).sel = 1
    RefreshDrawing
End Sub

Sub SelectFileToOpen
    DebugLog("SelectFileToOpen")
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "gbDesigner Data File" + $Nul + "*.gbd" + $Nul
    startfolder$ = CFN                 'initial folder to be displayed
    startfile$ = CFN                   'name to be used as initial selection
    defaultext$ = "gbd"                'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$,defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       CFN = filevar$
       OpenCFN(1,1)
    Else
       'ESC or cancel - no action
    End If
End Sub

Sub SaveFileAs
    DebugLog("SaveFileAs")
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""             'caption title. if "", then "Save As" is displayed
    startfolder$ = CFN      'initial folder to be displayed
    filter$ = "gbDesigner Data" + $Nul + "*.gbd" + $Nul
    startfile$ = CFN        'name to be used as initial selection
    defaultext$ = "gbd"     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
        CFN = filevar$
        DisplayCaption
        SaveFileName
    Else
        'Esc or Cancel - no action
    End If
End Sub

Sub DisplayPropertyDialog
  DebugLog("DisplayPropertyDialog")
  ReDim pArray(27)
  pArray(0) = "Name"     : pArray(1) = "Text"       : pArray(2) = "Image"   : pArray(3) = "Top"       :  pArray(4) = "Left"
  pArray(5) = "Width"    : pArray(6) = "Height"     : pArray(7) = "Tooltip" : pArray(8) = "FontName"  :  pArray(9) = "FontSize"
  pArray(10) = "FontAttr": pArray(11) = "FontColor" : pArray(12) = "Style"  : pArray(13) = "ExtStyle"
  pArray(14) = cList(ContextControl).cName
  pArray(15) = IIf$(Len(cList(ContextControl).txt),Trim$(cList(ContextControl).txt),"<empty>")
  pArray(16) = IIf$(Len(cList(ContextControl).imagefile),Trim$(cList(ContextControl).imagefile),"<empty>")
  pArray(17) = Str$(cList(ContextControl).x1)
  pArray(18) = Str$(cList(ContextControl).y1)
  pArray(19) = Str$(cList(ContextControl).x2 - cList(ContextControl).x1)
  pArray(20) = Str$(cList(ContextControl).y2 - cList(ContextControl).y1)
  pArray(21) = IIf$(Len(cList(ContextControl).tooltip),Trim$(cList(ContextControl).tooltip),"<empty>")
  pArray(22) = IIf$(Len(cList(ContextControl).fontname),Trim$(cList(ContextControl).fontname),"<empty> ")
  pArray(23) = Str$(cList(ContextControl).fontsize)
  pArray(24) = Str$(cList(ContextControl).fontattr)
  pArray(25) = Str$(cList(ContextControl).fontcolor)
  pArray(26) = Str$(cList(ContextControl).Style)
  pArray(27) = Str$(cList(ContextControl).extstyle)
  Dialog New Pixels, hOverlayDlg, "Property Dialog",100,100,200,185, %WS_SysMenu, 0 To hProperty
  Control Add ListBox, hProperty, %IDC_pListBox, pArray(), 0,0,200,200, %LBS_Notify Or %WS_TabStop Or %LBS_MultiColumn, %WS_Ex_Left
  Control Send hProperty, %IDC_pListBox, %LB_SetColumnWidth, 100, 0
  Dialog Show Modal hProperty Call PropertyProc
End Sub

CallBack Function PropertyProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         ListBox Select hProperty, %IDC_pListBox, 2
       Case %WM_Command
           Select Case Cb.Ctl
               Case %IdCancel    : Dialog End hProperty
               Case %IdOk        : EditProperty
               Case %IDC_pListBox : If Cb.CtlMsg = %LBN_DblClk Then EditProperty
           End Select
       Case %WM_SysCommand
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'traps Alt-F4, X-button, WindowMenu/Close
           SavePropertyValues
           ReBuildContextControl
           CreateCode
         End If

   End Select
End Function

Sub ReBuildContextControl
    'set new cID Name
    '   - no duplicates
    '   - valid string
    'set control to new style/exstyle
    'set new size/location
    Control Set Loc hDlg, cList(ContextControl).cID, cList(ContextControl).x1,  cList(ContextControl).y1
    Control Set Size  hDlg, cList(ContextControl).cID, cList(ContextControl).x2 - cList(ContextControl).x1, cList(ContextControl).y2 -  cList(ContextControl).y1
    Control Set Text hDlg, cList(ContextControl).cID, cList(ContextControl).txt
    'set new font name/size/attr/color
End Sub

Sub SavePropertyValues
    Local temp$
    ListBox Get Text hProperty, %IDC_pListBox, 15 To cList(ContextControl).cName
    ListBox Get Text hProperty, %IDC_pListBox, 16 To cList(ContextControl).txt
    ListBox Get Text hProperty, %IDC_pListBox, 17 To cList(ContextControl).imagefile
    ListBox Get Text hProperty, %IDC_pListBox, 18 To temp$ : cList(ContextControl).x1 = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 19 To temp$ : cList(ContextControl).y1 = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 20 To temp$ : cList(ContextControl).x2 = Val(temp$) + cList(ContextControl).x1
    ListBox Get Text hProperty, %IDC_pListBox, 21 To temp$ : cList(ContextControl).y2 = Val(temp$) + cList(ContextControl).y1
    ListBox Get Text hProperty, %IDC_pListBox, 22 To cList(ContextControl).tooltip
    ListBox Get Text hProperty, %IDC_pListBox, 23 To cList(ContextControl).fontname
    ListBox Get Text hProperty, %IDC_pListBox, 24 To temp$ : cList(ContextControl).fontsize = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 25 To temp$ : cList(ContextControl).fontattr = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 26 To temp$ : cList(ContextControl).fontcolor = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 27 To temp$ : cList(ContextControl).Style = Val(temp$)
    ListBox Get Text hProperty, %IDC_pListBox, 28 To temp$ : cList(ContextControl).extstyle = Val(temp$)
End Sub

Sub EditProperty
    DebugLog("EditProperty")
   Local x,y,w,h,iCount,iShift,iSelected As Long, value$,title$
   ListBox Get Count hProperty, %IDC_pListBox To iCount
   ListBox Get Select hProperty, %IDC_pListBox To iSelected
   'determine if in 1st column or second
   If iSelected <= iCount/2 Then
       iShift = iCount/2
       ListBox Get Text hProperty, %IDC_pListBox, iSelected To title$
   Else
       ListBox Get Text hProperty, %IDC_pListBox, iSelected-iCount/2 To title$
   End If
   'show InputBox next to dialog
   ListBox Get Text hProperty, %IDC_pListBox, iSelected + iShift To value$
   Dialog Get Loc hDlg To w,h
   Dialog Get Loc hProperty To x,y : x = x + w : y = y + h
   Dialog Get Size hProperty To w,h
   value$ = InputBox$("Enter " + title$ + ":","Edit Property", value$, x+w+20, y + 20)
   'validate results before committing to storage
   If Len(value$) Then ListBox Set Text hProperty, %IDC_pListBox, iSelected + iShift, value$
   ListBox Select hProperty, %IDC_pListBox, iSelected
End Sub

Sub DisplayOrderDialog
    Local i As Long
    DebugLog("DisplayOrderDialog")
    Dialog New Pixels, hDlg, "Set Tab Order",100,100,150,200, %WS_SysMenu, 0 To hOrder
    Control Add ListBox, hOrder, %IDC_zListBox, , 0,0,150,250
    For i = 1 To  UBound(cList)
       ListBox Insert hOrder, %IDC_zListBox, i, cList(i).cName
       ListBox Set User hOrder, %IDC_zListBox, i, i
    Next i
    Dialog Show Modal hOrder Call OrderProc
End Sub

CallBack Function OrderProc() As Long
    DebugLog("OrderProc")
   Local ptOrder As Point
   Static StartItem, EndItem, DragInWorkOrder As Long
   Select Case Cb.Msg
      Case %WM_SysCommand
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'traps Alt-F4, X-button, WindowMenu/Close
            RearrangeCList
         End If
      Case %WM_SetCursor
         GetCursorPos ptOrder
         ScreenToClient hOrder, ptOrder
         If GetDlgCtrlID (Cb.WParam) <> %IDC_zListBox Then Exit Function
         Select Case Hi(Word, Cb.LParam)  'monitors lbuttondown, mousemose, lbuttonup
               Case %WM_LButtonDown
                  DragInWorkOrder = 1
                  Control Send hOrder, %IDC_zListBox, %LB_ItemFromPoint, 0, Mak(Long, ptOrder.x, ptOrder.y) To StartItem
                  EndItem = 0
               Case %WM_MouseMove
                  If DragInWorkOrder Then
                     Control Send hOrder, %IDC_zListBox, %LB_ItemFromPoint, 0, Mak(Long, ptOrder.x, ptOrder.y) To EndItem
                     ArrangeListBoxItems StartItem, EndItem
                     DragInWorkOrder = 0
                  End If
         End Select
  End Select
End Function

Sub ArrangeListBoxItems(StartItem As Long, EndItem As Long)
    DebugLog("ArrangeListBoxItems")
   'place startitem in the position of enditem. maintain order above end position
   Local i, iCount, iUser, iStartUser As Long, StartText, temp As String
   Incr StartItem : Incr EndItem    'arguments are zero-based values
   ListBox Get Count hOrder, %IDC_zListBox To iCount
   ListBox Get Text hOrder, %IDC_zListBox, StartItem To StartText
   ListBox Get User hOrder, %IDC_zListBox, StartItem To iStartUser
   If (StartItem = EndItem) Or (StartItem > iCount) Or (EndItem > iCount) Then Exit Sub
   If StartItem < EndItem Then     'start is above end
      For i = StartItem To EndItem-1
         ListBox Get Text hOrder, %IDC_zListBox, i+1 To temp
         ListBox Get User hOrder, %IDC_zListBox, i+1 To iUser
         ListBox Set Text hOrder, %IDC_zListBox, i, temp
         ListBox Set User hOrder, %IDC_zListBox, i, iUser
      Next i
      ListBox Set Text hOrder, %IDC_zListBox, EndItem, StartText
      ListBox Set User hOrder, %IDC_zListBox, EndItem, iStartUser
   Else    'end is above start
      For i = StartItem To EndItem+1 Step -1
         ListBox Get Text hOrder, %IDC_zListBox, i-1 To temp
         ListBox Get User hOrder, %IDC_zListBox, i-1 To iUser
         ListBox Set Text hOrder, %IDC_zListBox, i, temp
         ListBox Set User hOrder, %IDC_zListBox, i, iUser
      Next i
      ListBox Set Text hOrder, %IDC_zListBox, EndItem, StartText
      ListBox Set User hOrder, %IDC_zListBox, EndItem, iStartUser
   End If
End Sub

Sub NewDesign
    DebugLog("NewFile")
    If ConfirmDeleteAll And UBound(cList)>0 And MsgBox("Delete All Controls?", %MB_OkCancel + %MB_IconQuestion, "New Design") = %IdCancel Then Exit Sub
    CFN = EXE.Path$ + "temp.gbd"
    DeleteAllControls
End Sub

Sub SelectControlsInSelection
    DebugLog("SelectControlsInSelection")
    Local i As Long
    For i = 1 To UBound(cList)
'     If (RectA.X1 < RectB.X2 && RectA.X2 > RectB.X1 && RectA.Y1 < RectB.Y2 && RectA.Y2 > RectB.Y1)
      If  (cList(i).x1 > pt.x) Or (ptDrawOrig.x > cList(i).x2) Or (cList(i).y1 > pt.y) Or (cList(i).y2 < ptDrawOrig.y) Then
         'no overlap - take no action
      Else
         cList(i).Sel = 1   'overlap
      End If
    Next i
End Sub

Sub DeleteAllControls
    DebugLog("ClearDrawing")
    Local i As Long
    For i = 1 To UBound(cList)
        Control Kill hDlg, cList(i).cID
    Next i
    ReDim cList(0)
    CreateCode
    RefreshDrawing
    DisplayCaption
End Sub

Sub CreateInvisibleBitmap
    DebugLog("CreateInvisibleBitmaps")
    Local w,h As Long
    Desktop Get Client To w,h
    Graphic Bitmap New w,h To hBMP
    Graphic Attach hBMP, 0
    Graphic Get DC To memDC
End Sub

Sub RefreshDrawing   'using PB Bitmap
    DebugLog("RefreshDrawing")

    If DesignMode = 0 Then Exit Sub

    Local i,iColor,x,y,w,h, DefaultColor As Long
    Dialog Get Client hOverlayDlg To w,h
    Graphic Get Pixel(5,5) To DefaultColor

   'use the hidden bitmap
    Graphic Clear           'GetSysColorBrush(%COLOR_3DFACE)   'clear/fill with color

   'draw grid
   If ShowGrid Then
       For x = DisplayGridSize To w Step DisplayGridSize
          For y = (DisplayGridSize - yToolbar) To h Step DisplayGridSize
             Graphic Box (x-1,y-1) - (x+1,y+1), %Black
          Next y
       Next x
   End If

   'draw control boundaries (LineMode=1 only)
   If LineMode Then
       For i = 1 To UBound(cList)
          Graphic Box (cList(i).x1, cList(i).y1-yToolbar) - (cList(i).x2, cList(i).y2-yToolbar),, %Black, %rgb_LightBlue
          If LineModeLabels Then
              Graphic Set Pos (cList(i).x1+2, cList(i).y1+2-yToolbar)
              Graphic Color %Black, %rgb_LightBlue
              Graphic Print ControlNames(cList(i).cType) + Str$(cList(i).cID)
              Graphic Color %Black, DefaultColor
          End If
       Next i
   End If

   'draw control selection markers
    For i = 1 To UBound(cList)
        If cList(i).sel Then
            Graphic Box (cList(i).x1-SelectBoxSize, cList(i).y1-SelectBoxSize-yToolbar) - (cList(i).x1, cList(i).y1-yToolbar),, %Red, %White 'upper left
            Graphic Box (cList(i).x2, cList(i).y1-SelectBoxSize-yToolbar) - (cList(i).x2+SelectBoxSize, cList(i).y1-yToolbar),, %Red, %White 'upper right
            Graphic Box (cList(i).x1-SelectBoxSize, cList(i).y2-yToolbar) - (cList(i).x1, cList(i).y2+SelectBoxSize-yToolbar),, %Red, %White 'lower left
            Graphic Box (cList(i).x2, cList(i).y2-yToolbar) - (cList(i).x2+SelectBoxSize, cList(i).y2+SelectBoxSize-yToolbar),, %Red, %White 'lower right
        End If
    Next i

    'draw rectangle that follows the mouse

    If DrawInWork Then
       Graphic Style IIf(CurrentControlType = %IDM_Select, 1, 0)
       iColor = IIf(CurrentControlType = %IDM_Select, %Red, %Black)
       Graphic Line (ptDrawOrig.x, ptDrawOrig.y-yToolbar)-(pt.x, ptDrawOrig.y-yToolbar), iColor
       Graphic Line Step  - (pt.x,pt.y-yToolbar), iColor
       Graphic Line Step  - (ptDrawOrig.x, pt.y-yToolbar), iColor
       Graphic Line Step  - (ptDrawOrig.x, ptDrawOrig.y-yToolbar), iColor
    End If

    hDC = GetDC(hOverlayDlg)
    BitBlt hDC, 0, 0, w, h, memDC, 0, 0, %SRCCopy
    ReleaseDC(hOverlayDlg,hDC)
End Sub

Sub CPrint (txtA As String)
    Static cWritten As Long
    Local SOut As String
    Incr iMsgCount : If iMsgCount& > 9999 Then iMsgCount& = 1
    SOut = Format$(iMsgCount&,"* ###0") + " " + txtA
    If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
    WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub AddNewControl(i As Long, Flag As Long)
    DebugLog("AddNewControl")
    Local hItem, hTemp As Dword, cID,x,y,w,h,hPage As Long, txt As String
    Dim gbArray(3) As String
    Array Assign gbArray() = "zero", "one", "two", "three"

    'create the control
     x = cList(i).x1     : y = cList(i).y1 - yToolbar
     w = cList(i).x2 - x : h = cList(i).y2 - y - yToolbar
     cID = BaseID + i   'If Flag Then cID = BaseID + i Else cID = cList(i).cID
     txt = cList(i).txt

     If LineMode = 0 Then
         Select Case cList(i).cType
            Case %IDM_Button
                Control Add Button, hDlg, cID, txt, x,y+yToolbar,w,h,%BS_Center Or %BS_VCenter Or %WS_TabStop,%WS_Ex_Left
            Case %IDM_Check3State
                Control Add Check3State, hDlg, cID, txt, x,y+yToolbar,w,h,%BS_Left Or %BS_VCenter Or %WS_TabStop, %WS_Ex_Left
            Case %IDM_CheckBox
                Control Add CheckBox, hDlg, cID, txt, x,y+yToolbar,w,h,%BS_Left Or %BS_VCenter Or %WS_TabStop, %WS_Ex_Left
                SetToTrueSize i
            Case %IDM_ComboBox
                Control Add ComboBox, hDlg, cID, , x,y+yToolbar,w,100,%CBS_DropDown Or %CBS_Sort Or %WS_TabStop,%WS_Ex_Left Or %WS_Ex_ClientEdge
                'note the 100. h is the size of the listbox without a dropdown. must assign a value (100 is arbitrary) to cover dropdown
                ComboBox Insert hDlg, cID, 1, "ListBox"
                ComboBox Select hDlg, cID, 1
                SetToTrueSize i
            Case %IDM_Frame
                Control Add Frame, hDlg, cID, txt, x,y+yToolbar,w,h,%BS_Left Or %BS_Top, %WS_Ex_Left Or %WS_Ex_Transparent
            Case %IDM_Graphic
                Control Add Graphic, hDlg, cID, "", x,y+yToolbar,w,h,%WS_Visible Or %WS_Border Or %SS_Notify,0
'                Graphic Attach hDlg, cID, ReDraw
'                Graphic Render "garyface.bmp", (0,0)-(100,100)
'                Graphic Redraw
'                Graphic Detach
            Case %IDM_Image
                Control Add Image, hDlg, cID, "garyface", x,y+yToolbar,w,h,%SS_CenterImage Or %WS_Border Or %WS_TabStop,%WS_Ex_Left
            Case %IDM_ImageX
                Control Add ImageX, hDlg, cID, "garyface", x,y+yToolbar,w,h,%WS_Border Or %WS_TabStop,%WS_Ex_Left
            Case %IDM_ImgButton
                Control Add ImgButton, hDlg, cID, "garyface", x,y+yToolbar,w,h,%WS_Border Or %WS_TabStop,%WS_Ex_Left
                SetToTrueSize i
            Case %IDM_ImgButtonX
                Control Add ImgButtonX, hDlg, cID, "garyface", x,y+yToolbar,w,h,%WS_Border Or %WS_TabStop,%WS_Ex_Left
            Case %IDM_Label
                Control Add Label,  hDlg, cID, txt, x,y+yToolbar,w,h,%SS_Center Or %SS_CenterImage,%WS_Ex_Left
            Case %IDM_Line
                Control Add Line, hDlg, cID, txt, x,y+yToolbar,w,h, %SS_EtchedFrame, %WS_Ex_Left Or %WS_Ex_Transparent
'                Control Set Color hDlg, cID, %Black, %Black
            Case %IDM_ListBox
                Control Add ListBox, hDlg, cID, , x,y+yToolbar,w,h,%LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll,%WS_Ex_Left Or %WS_Ex_ClientEdge
                ListBox Insert hDlg, cID, 1, "ListBox"
                SetToTrueSize i
            Case %IDM_ListView
                Control Add ListView, hDlg, cID, txt, x,y+yToolbar,w,h,%WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %WS_Border,%WS_Ex_Left
                ListView Insert Column hDlg, cID, 1, "test1", 75, 0  'columns
                ListView Insert Column hDlg, cID, 2, "test2", 75, 0
                ListView Insert Item hDlg, cID, 1, 1, "one"          'row 1, col1
                ListView Insert Item hDlg, cID, 2, 2, "two"          'row 2, col1
                ListView Set Text hDlg, cID, 1,2, "12"               'row1 col2
                ListView Set Text hDlg, cID, 2,2, "22"               'row2 col2
                ListView Set Mode hDlg, cID, 1  '0-icon 1-report 2-small 3-list
                ListView Set StyleXX hDlg, cID, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
                ListView Set StyleXX hDlg, cID, %LVS_Ex_FullRowSelect
            Case %IDM_Option
                Control Add Option,     hDlg, cID, txt, x,y+yToolbar,w,h,%WS_TabStop Or %BS_Left Or %BS_VCenter,%WS_Ex_Left
                SetToTrueSize i
            Case %IDM_ProgressBar
                Control Add Progressbar,hDlg, cID, txt, x,y+yToolbar,w,h,%WS_Border,%WS_Ex_ClientEdge
                Progressbar Set Pos hDlg, cID,80
                Control Set Color hDlg, cID, %Red, %Blue
            Case %IDM_HScrollBar
                Control Add ScrollBar,  hDlg, cID, txt, x,y+yToolbar,w,h,%SBS_Horz,%WS_Ex_Left
                SetToTrueSize i
            Case %IDM_VScrollBar
                Control Add ScrollBar,  hDlg, cID, txt, x,y+yToolbar,w,h,%SBS_Vert,%WS_Ex_Left
                SetToTrueSize i
            Case %IDM_StatusBar
                Control Add Statusbar,  hDlg, cID, txt, x,y+yToolbar,w,h,%CCS_Bottom,%WS_Ex_ClientEdge
                Statusbar Set Parts hDlg, cID, 200,99999   'width each part
                Statusbar Set Text hDlg, cID, 1, 0, "one"
                Statusbar Set Text hDlg, cID, 2, 0, "two"
                SetToTrueSize i
            Case %IDM_Tab
                Control Add Tab, hDlg, cID, txt, x,y+yToolbar,w,h,%WS_Child Or %WS_TabStop,0
                Tab Insert Page hDlg, cID, 1, 0, "Page 1" To hPage
                Tab Insert Page hDlg, cID, 2, 0, "Page 2" To hPage
            Case %IDM_TextBox
                Control Add TextBox, hDlg, cID, txt, x,y+yToolbar,w,h,%WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoHScroll Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn, %WS_Ex_ClientEdge Or %WS_Ex_Left
            Case %IDM_Toolbar
                Control Add Toolbar, hDlg, cID, txt, x,y+yToolbar,w,h,%WS_Child Or %WS_Visible Or %WS_Border Or %CCS_Top Or %TbStyle_Flat,%WS_Ex_ClientEdge
                Toolbar Set ImageList hDlg, cID, hCodeLst, 0
                Toolbar Add Button    hDlg, cID, 1, 800, %TbStyle_Button, ""
                Toolbar Add Button    hDlg, cID, 2, 801, %TbStyle_Button, ""
                SetToTrueSize i
            Case %IDM_TreeView
                Control Add Treeview, hDlg, cID, txt, x,y+yToolbar,w,h,%TVS_TrackSelect Or %WS_TabStop Or %TVS_HasButtons Or %TVS_LinesAtRoot Or %TVS_HasLines Or %TVS_ShowSelAlways Or %TVS_EditLabels, %WS_Ex_Left Or %WS_Ex_ClientEdge
                Treeview Set ImageList hDlg, cID, hCodeLst
                Treeview Insert Item hDlg, cID, 0, %TVI_Last, 1,1,"One" To hItem
                Treeview Insert Item hDlg, cID, hItem, %TVI_Last, 1,1,"One-1" To hTemp
                Treeview Insert Item hDlg, cID, hItem, %TVI_Last, 1,1,"One-2" To hTemp

                Treeview Insert Item hDlg, cID, 0, %TVI_Last, 2,2,"Two" To hItem
                Treeview Insert Item hDlg, cID, hItem, %TVI_Last, 2,2,"Two-1" To hTemp
                Treeview Insert Item hDlg, cID, hItem, %TVI_Last, 2,2,"Two-2" To hTemp
         End Select
         Control ReDraw hDlg, cID
         Control Handle hDlg, cID To cList(i).Handle
     End If
End Sub

Sub SetControlNames
    DebugLog("LoadControlCodeNames")
    ReDim ControlNames(400 To 599), ControlCodeStd(400 To 599), ControlCodeExp(400 To 599)
    ControlNames(400) = "Select"
    ControlNames(401) = "Button"
    ControlNames(402) = "Check3State"
    ControlNames(403) = "CheckBox"
    ControlNames(404) = "ComboBox"
    ControlNames(405) = "Frame"
    ControlNames(406) = "Graphic"
    ControlNames(407) = "Image"
    ControlNames(408) = "Imagex"
    ControlNames(409) = "ImgButton"
    ControlNames(410) = "ImgButtonX"
    ControlNames(411) = "Label"
    ControlNames(412) = "Line"
    ControlNames(413) = "ListBox"
    ControlNames(414) = "ListView"
    ControlNames(415) = "Option"
    ControlNames(416) = "ProgressBar"
    ControlNames(417) = "HScrolLBar"
    ControlNames(418) = "VScrollBar"
    ControlNames(419) = "StatusBar"
    ControlNames(420) = "TAB"
    ControlNames(421) = "TextBox"
    ControlNames(422) = "Toolbar"
    ControlNames(423) = "TreeView"
    '-- custom controls ---------
    'none
End Sub

Sub CreateCode
    DebugLog("DesignModeSettings")

    Local gb_equates, gb_globals, gb_initialize, gb_command, gb_notify, gb_controls, D As String
    Local i,x,y,w,h As Long

    If SDKCode = 1 Then
        SDKCode = 0
        Menu Set State hSettings, ByCmd %IDM_SDKCode, SDKCode * 8
        Control Set Text hDlg, %IDC_CodeBox, "SDK code option not available!"
        MsgBox "SDK feature not yet supported!", %MB_Ok + %MB_IconInformation, "SDK Code"
    End If

    If UseExpandedCode Then
        cCode = dialogtemplate
        Dialog Get Client hDlg To w,h
        Dialog Get Loc hDlg To x,y
        D = Str$(x) + "," + Str$(y) + "," + Str$(w) + "," + Str$(h-yCodeBox-yToolbar)
        Replace "x,y,w,h" With D In cCode
    Else
        cCode = "'gb_equates" + $CrLf + "'gb_controls"
    End If

    For i = 1 To UBound(cList)
        D = Str$(cList(i).x1) + "," + Str$(cList(i).y1) + "," + Str$(cList(i).x2 - cList(i).x1) + "," + Str$(cList(i).y2 - cList(i).y1)
        If UseExpandedCode Then
            gb_controls = gb_controls + $CrLf + ControlCodeExp(cList(i).cType)   'exanded code
        Else
            gb_controls = gb_controls + $CrLf + ControlCodeStd(cList(i).cType)   'minimal code
        End If
        gb_controls = Trim$(gb_controls,$CrLf)
        gb_equates = gb_equates + cList(i).cName + " = " + Format$(cList(i).cID,"0000") + $CrLf
        Replace "vID" With Format$(i,"0000") In gb_controls
        Replace "cID" With cList(i).cName In gb_controls
        Replace "cTxt" With Chr$(34) + cList(i).txt + Chr$(34) In gb_controls
        Replace "x,y,w,h" With D In gb_controls
   Next i

   If UseExpandedCode Then
       Replace "'gb_globals" With gb_globals In cCode
       Replace "'gb_initialize" With gb_initialize In cCode
       Replace "'gb_command" With gb_command In cCode
       Replace "'gb_notify" With gb_notify In cCode
   End If
   Replace "'gb_equates" With gb_equates In cCode
   Replace "'gb_controls" With gb_controls In cCode

   If DisplayCodeBox Then
       Control Set Text hDlg, %IDC_CodeBox, Trim$(cCode, $CrLf)
       Control Send hDlg, %IDC_CodeBox, %EM_LineScroll, 0, 99999
   End If
End Sub

CallBack Function OverlayProc() As Long
   Local i,x,y,w,h,iReturn As Long
   Local trackMouseC As TrackMouseEventAPI
   Static MouseInC As Dword

   Select Case Cb.Msg
      Case %WM_InitDialog
         DesignModeSettings

      Case %WM_MouseLeave
         MouseInC = %False
         ResizeControlInWork = 0 : DrawInWork = 0 : MoveInWork = 0 : RefreshDrawing

      Case %WM_MouseMove
         If MouseInC = %False Then
           MouseInC = %TRUE
           trackMouseC.cbSize = SizeOf(trackMouseC)
           trackMouseC.dwFlags = %TME_LEAVE
           trackMouseC.hwndTrack = hOverlayDlg
           TrackMouseEvent(trackMouseC)
         End If

     Case %WM_LButtonDblClk
        'overlayDlg doubleclick
        ContextControl = IsMouseOverControl
        If ContextControl Then
           DisplayPropertyDialog   'DisplayContextControlData
        Else
           DisplayToolbar = 1
           FloatingToolbar = FloatingToolbar Xor 1 : DesignModeSettings
        End If
        DrawInWork = 0 : MoveInWork = 0 : ResizeControlInWork = 0   'special case where dblclk was made where toolbar will be shown

      Case %WM_ContextMenu
         ContextControl = IsMouseOverControl
         If ContextControl Then
             x = Lo(Word,Cb.LParam) : y = Hi(Word, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
             TrackPopupMenu hControlContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
             Function = 0 : Exit Function
         Else
             x = Lo(Word,Cb.LParam) : y = Hi(Word, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
             TrackPopupMenu hDialogContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
             Function = 0 : Exit Function
         End If

      Case %WM_SetCursor ' And DesignMode
          Dialog Get Client hDlg To w,h
          GetCursorPos pt                 'screen position
          ScreenToClient hOverlayDlg, pt  'overlay position
          pt.y = pt.y + yToolbar          'hDlg position

          truept = pt
          If SnapToGrid Then AdjustPTtoGrid
          SA = Str$(pt.x) + " : " + Str$(pt.y) + "   (" + Str$(truept.x) + " : " + Str$(truept.y) + ")"  : DisplayCaption

          iReturn = GetDlgCtrlID (Cb.WParam) 'identify over which label control the mouse action took place
          If DisplayToolbar And iReturn = %IDC_ToolbarA Then Exit Function
          If DisplayCodeBox And iReturn = %IDC_CodeBox Then Exit Function

            Select Case Hi(Word, Cb.LParam)  'monitors the 3 basic mouse actions, lbuttondown, mousemose, lbuttonup
               Case %WM_LButtonDown
                   ctlDrag = IsMouseOverControl   'test for dragging only if not resizing
                   If ctlDrag = 0 Then ctlResize = IsMouseOverSelectBox()   'test for resizing control
                   If ctlDrag Then
                      'control selected, about to drag the control
                      ptDragOrig = pt
                      cList(ctlDrag).sel = cList(ctlDrag).sel Xor 1
                      If cList(ctlDrag).sel Then CurrentControl = ctlDrag  'sets value for using TAB
                      MoveInWork = 1
                      For i = 1 To UBound(cList)
                          cList(i).dragdeltax = pt.x - cList(i).x1
                          cList(i).dragdeltay = pt.y - cList(i).y1
                      Next i
                      RefreshDrawing
                   ElseIf ctlResize Then
                      'resizing a control
                      ResizeControlInWork = 1
                      resizeptx = pt.x : resizepty = pt.y
                   ElseIf (pt.x>-1) And (pt.x<(w+1)) And (pt.y > -1) And (pt.y <h) Then 'inside GUI bounds
                      DrawInWork = 1
                      ptDrawOrig = pt
                      SC = "Mouse is down at " + Str$(pt.x) + " : " + Str$(pt.y) : DisplayCaption
                   End If
               Case %WM_MouseMove
                   If ResizeControlInWork Then
                       iReturn = 0  'resizing a control
                       Select Case ctlCorner   'which corner is being dragged
                           Case 1   'upper left
                               If pt.x < cList(ctlResize).x2 And pt.y < cList(ctlResize).y2 Then
                                   cList(ctlResize).x1 = pt.x
                                   cList(ctlResize).y1 = pt.y
                                   iReturn = 1
                               End If
                           Case 2   'upper right
                               If pt.x > cList(ctlResize).x1 And pt.y < cList(ctlResize).y2 Then
                                   cList(ctlResize).x2 = pt.x
                                   cList(ctlResize).y1 = pt.y
                                   iReturn = 1
                               End If
                           Case 3   'lower right
                               If pt.x > cList(ctlResize).x1 And pt.y > cList(ctlResize).y1 Then
                                   cList(ctlResize).x2 = pt.x
                                   cList(ctlResize).y2 = pt.y
                                   iReturn = 1
                               End If
                           Case 4   'lower left
                               If pt.x < cList(ctlResize).x2 And pt.y > cList(ctlResize).y1 Then
                                   cList(ctlResize).x1 = pt.x
                                   cList(ctlResize).y2 = pt.y
                                   iReturn = 1
                               End If
                       End Select


                       If iReturn And (LineMode=0) Then
                          Select Case cList(ctlResize).cType   'special cases
                              Case %IDM_Graphic                'does not support resize
                                 'must kill before resizing
                                 Control Kill hDlg, cList(ctlResize).cID
                                 h = cList(ctlResize).y2 - cList(ctlResize).y1
                                 w = cList(ctlResize).x2 - cList(ctlResize).x1
                                 Control Add Graphic, hDlg, cList(ctlResize).cID, "", cList(ctlResize).x1, cList(ctlResize).y1,w,h,%WS_Visible Or %WS_Border Or %SS_Notify,0
 '                             Case %IDM_Image, %IDM_ImageX, %IDM_ImgButton, %IDM_ImgButtonX
 '                                Dialog ReDraw hDlg
                          End Select
                          If iReturn Then
                              Control Set Loc hDlg, cList(ctlResize).cid, cList(ctlResize).x1, cList(ctlResize).y1
                              Control Set Size hDlg, cList(ctlResize).cid, cList(ctlResize).x2-cList(ctlResize).x1, cList(ctlResize).y2-cList(ctlResize).y1
                              Control ReDraw hDlg, cList(ctlResize).cid
                          End If
                       End If
                       Dialog ReDraw hDlg
'                       InvalidateRect(hDlg, ByVal 0, %False) : UpdateWindow(hDlg)  'Dialog ReDraw hDlg
'                       InvalidateRect(hOverlayDlg, ByVal 0, %False) : UpdateWindow(hOverlayDlg)  'Dialog ReDraw hDlg
                       RefreshDrawing

                   ElseIf MoveInWork Then
                       'dragging control(s) to new location
                       cList(ctlDrag).sel = 1
                       For i = 1 To UBound(cList)
                           If cList(i).sel Then
                               w = cList(i).x2 - cList(i).x1
                               h = cList(i).y2 - cList(i).y1
                               cList(i).x1 = pt.x - cList(i).dragdeltax
                               cList(i).x2 = cList(i).x1 + w
                               cList(i).y1 = pt.y - cList(i).dragdeltay
                               cList(i).y2 = cList(i).y1 + h
                               Control Set Loc hDlg, cList(i).cid, cList(i).x1, cList(i).y1   'If LineMode = 0
                           End If
                       Next i
'                       Select Case cList(ctlDrag).cType
'                          Case %IDM_Image, %IDM_ImageX, %IDM_ImgButton, %IDM_ImgButtonX
'                             Dialog ReDraw hDlg
'                       end Select
                        Dialog ReDraw hDlg
'                       InvalidateRect hDlg, ByVal 0, %False : UpdateWindow hDlg  'Dialog ReDraw hDlg
'                       InvalidateRect(hOverlayDlg, ByVal 0, %False) : UpdateWindow(hOverlayDlg)  'Dialog ReDraw hDlg
                       RefreshDrawing
                   ElseIf DrawInWork Then
                       SC = "Mouse down and moving at " + Str$(pt.x) + " : " + Str$(pt.y)
                       DisplayCaption
                       RefreshDrawing
                   End If
               Case %WM_LButtonUp
                   If ResizeControlInWork Then
                       SetToTrueSize(ctlResize)
                       ResizeControlInWork = 0
                       CreateCode
                   ElseIf MoveInWork Then
'                      If ptDragOrig = pt then cList(ctlDrag).sel = 0  'if position not changed, unselect
                       MoveInWork = 0
                       CreateCode
                   ElseIf DrawInWork Then
                       'order dimensions upper left to lower right
                       If pt.x < ptDrawOrig.x Then iReturn = pt.x : pt.x =  ptDrawOrig.x : ptDrawOrig.x = iReturn
                       If pt.y < ptDrawOrig.y Then iReturn = pt.y : pt.y =  ptDrawOrig.y : ptDrawOrig.y = iReturn
                       If (pt.x - ptDrawOrig.x) And (pt.y - ptDrawOrig.y) And (CurrentControlType <> %IDM_Select) Then  'non-zero movement, draw mode
                           i = UBound(cLIst) + 1
                           ReDim Preserve cList(i)
                           'store dimensions
                           cList(i).x1 = ptDrawOrig.x : cList(i).y1 = ptDrawOrig.y
                           cList(i).x2 = pt.x     : cList(i).y2 = pt.y
                           cList(i).cType = CurrentControlType
                           cList(i).cID = BaseID + UBound(cList)
                           cList(i).cName = "%IDC_" + ControlNames(CurrentControltype) + "_" + Format$(cList(i).cID,"0000")
                           cList(i).txt = IIf$(NumericLabels, Str$(cList(i).cID), ControlNames(CurrentControlType))
                           AddNewControl UBound(cList), 1   '1=new cID 0=same cID
                       ElseIf (pt.x - ptDrawOrig.x) And (pt.y - ptDrawOrig.y) And (CurrentControlType = %IDM_Select) Then 'non-zero movement, select mode
                           SelectControlsInSelection
                       Else
                           UnSelectAll
                       End If
                       DrawInWork = 0
                       CreateCode
                       RefreshDrawing
                       SC = "Mouse is up at " + Str$(pt.x) + " : " + Str$(pt.y) : DisplayCaption
                   End If
            End Select
   End Select
End Function

Sub DesignModeSettings
    DebugLog("DesignModeSettings")

    Local w As Long

    'Overlay
    Dialog Show State hOverlayDlg, IIf(DesignMode, %SW_Show, %SW_Hide)

    'Context Menu
    Menu Set State hSettings, ByCmd %IDM_DesignMode, DesignMode * 8
    Menu Set State hSettings, ByCmd %IDM_DisplayCodeBox, DisplayCodeBox * 8
    Menu Set State hSettings, ByCmd %IDM_DisplayToolbar, DisplayToolbar * 8
    Menu Set State hSettings, ByCmd %IDM_FloatingToolbar, FloatingToolbar * 8
    Menu Set State hSettings, ByCmd %IDM_LineMode, LineMode * 8
    Menu Set State hDialogContext, ByCmd CurrentControlType, 8

    'CodeBox
    If DesignMode And DisplayCodeBox Then
        Control Get Size hDlg, %IDC_CodeBox To w, yCodeBox
        Control Show State hDlg, %IDC_CodeBox, %SW_Show
    Else
        Control Show State hDlg, %IDC_CodeBox, %SW_Hide
        yCodeBox = 0
    End If

    'ToolbarA,B,C
    If DesignMode And (FloatingToolbar = 0) And DisplayToolbar Then
        Control Show State hDlg, %IDC_ToolbarA, %SW_Show
        Control Get Size hDlg, %IDC_ToolbarA To w, yToolbar
    Else
        Control Show State hDlg, %IDC_ToolbarA, %SW_Hide
        yToolbar = 0
    End If

    If ExpandToolbar Then
        Toolbar Set State hDlg,      %IDC_ToolbarA, ByCmd %IDM_DesignMode,     IIf(DesignMode, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)
        Toolbar Set State hDlg,      %IDC_ToolbarA, ByCmd %IDM_DisplayCodeBox, IIf(DisplayCodeBox, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)
        Toolbar Set State hDlg,      %IDC_ToolbarA, ByCmd %IDM_LineMode,       IIf(LineMode, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)
    End If
    Toolbar Set State hFloatDlg, %IDC_ToolbarB, ByCmd %IDM_DesignMode,     IIf(DesignMode, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)
    Toolbar Set State hFloatDlg, %IDC_ToolbarB, ByCmd %IDM_DisplayCodeBox, IIf(DisplayCodeBox, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)
    Toolbar Set State hFloatDlg, %IDC_ToolbarB, ByCmd %IDM_LineMode,       IIf(LIneMode, %TBState_Enabled Or %TBState_Checked,%TBState_Enabled)

    'Floating Dialog
    Dialog Show State hFloatDlg, IIf(DesignMode And FloatingToolbar And DisplayToolbar, %SW_Show, %SW_Hide)

    If LineMode Then
         SetLayeredWindowAttributes(hOverlayDlg, %Blue, 255, %LWA_ALPHA)
    Else
         SetLayeredWindowAttributes(hOverlayDlg, %Blue, 70, %LWA_ALPHA)
    End If

    If DesignMode Then RefreshDrawing
    ResizeWindow
    DisplayCaption
End Sub

Sub CreateFloatingDialog
    DebugLog("CreateFloatingDialog")
    Dialog New Pixels, 0, "Controls",FLeft,FTop,FWidth,FHeight, %WS_SysMenu Or %WS_Border To hFloatDlg
    CreateFloatingToolbars
    Toolbar Set State hFloatDlg, %IDC_ToolbarC, ByCmd CurrentControlType, %TBState_Enabled Or %TBState_Checked
    Dialog Show Modeless hFloatDlg Call FloatProc
End Sub

CallBack Function FloatProc() As Long
   Local tempAsciiZ As Asciiz * %Max_Path
   Select Case Cb.Msg
      Case %WM_InitDialog
          SetWindowPos(hFloatDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NoMove Or %SWP_NoSize)  'on Top


      Case %WM_Destroy
          Dialog Get Loc hFloatDlg To FLeft, FTop
          Dialog Get Client hFloatDlg To FWidth, FHeight
          tempASCIIZ = Str$(FLeft ) : WritePrivateProfileString "All", "FLeft", tempASCIIZ, INIFileName
          tempASCIIZ = Str$(FTop)   : WritePrivateProfileString "All", "FTop", tempASCIIZ, INIFileName
          tempASCIIZ = Str$(FWidth) : WritePrivateProfileString "All", "FWidth", tempASCIIZ, INIFileName
          tempASCIIZ = Str$(FHeight): WritePrivateProfileString "All", "FHeight", tempASCIIZ, INIFileName

'     Case %WM_SetCursor
'         SetFocus hFloatDlg

'      Case %WM_NCActivate
'          If IsFalse(Cb.WParam) Then Function = 1

      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
            FloatingToolbar = 0
            DesignModeSettings
            Function = 1   'True - abort the close - no further processing needed
         End If

      Case %WM_Notify
           If Cb.NmCode = %TTN_GetDispInfo Then
              Local P As TOOLTIPTEXT Ptr
                 P = Cb.LParam
                 Select Case Cb.NmId          'or this:   @P.hdr.idFrom
                    Case %IDM_New         : @P.@lpszText = "New"
                    Case %IDM_Open        : @P.@lpszText = "Open"
                    Case %IDM_Save        : @P.@lpszText = "Save"
                    Case %IDM_SaveAs      : @P.@lpszText = "Save As"

                    Case %IDM_DesignMode  : @P.@lpszText = "Design Mode"
                    Case %IDM_LineMode    : @P.@lpszText = "Line Mode"
                    Case %IDM_DeleteAll   : @P.@lpszText = "Delete All Controls"
                    Case %IDM_Undo        : @P.@lpszText = "Undo (Delete Last Control)"

                    Case %IDM_OpenInIDE   : @P.@lpszText = "Open Code In IDE"
                    Case %IDM_CopyCode    : @P.@lpszText = "Copy Code"
                    Case %IDM_DisplayCodeBox : @P.@lpszText = "Display Code Box"
                    Case %IDM_ShowCode    : @P.@lpszText = "Show Code (Notepad)"

                    Case %IDM_Select      : @P.@lpszText = "Select"
                    Case %IDM_Button      : @P.@lpszText = "Button"
                    Case %IDM_Check3State : @P.@lpszText = "Check3State"
                    Case %IDM_CheckBox    : @P.@lpszText = "Checkbox"
                    Case %IDM_ComboBox    : @P.@lpszText = "ComboBox"
                    Case %IDM_Frame       : @P.@lpszText = "Frame"
                    Case %IDM_Graphic     : @P.@lpszText = "Graphic"
                    Case %IDM_Image       : @P.@lpszText = "Image"
                    Case %IDM_ImageX      : @P.@lpszText = "ImageX"
                    Case %IDM_ImgButton   : @P.@lpszText = "ImgButton"
                    Case %IDM_ImgButtonX  : @P.@lpszText = "ImgButtonX"
                    Case %IDM_Label       : @P.@lpszText = "Label"
                    Case %IDM_Line        : @P.@lpszText = "Line"
                    Case %IDM_ListBox     : @P.@lpszText = "ListBox"
                    Case %IDM_ListView    : @P.@lpszText = "Listview"
                    Case %IDM_Option      : @P.@lpszText = "Option"
                    Case %IDM_ProgressBar : @P.@lpszText = "ProgressBar"
                    Case %IDM_HScrollbar  : @P.@lpszText = "HScrollbar"
                    Case %IDM_VScrollbar  : @P.@lpszText = "VScrollbar"
                    Case %IDM_StatusBar   : @P.@lpszText = "StatuBar"
                    Case %IDM_TAB         : @P.@lpszText = "TAB"
                    Case %IDM_TextBox     : @P.@lpszText = "TextBox"
                    Case %IDM_Toolbar     : @P.@lpszText = "Toolbar"
                    Case %IDM_TreeView    : @P.@lpszText = "TreeView"
                 End Select
           End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case 400 To 599
                Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd CurrentControlType, %TBState_Enabled
                CurrentControlType = Cb.Ctl
                ReSetContextControlMenu
                DesignModeSettings
                Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd CurrentControlType, %TBState_Enabled Or %TBState_Checked

            Case %IDM_New              : NewDesign
            Case %IDM_Open             : SelectFileToOpen
            Case %IDM_Save             : SaveFileName
            Case %IDM_SaveAs           : SaveFileAs

            Case %IDM_Undo             : Undo
            Case %IDM_DeleteAll
               If ConfirmDeleteAll And UBound(cList)>0 And MsgBox("Delete All Controls?", %MB_OkCancel + %MB_IconQuestion, "Delete All Controls") = %IdOk Then DeleteAllControls

            Case %IDM_DesignMode, %IDM_DesignMode : DesignMode = DesignMode Xor 1 : DesignModeSettings : Dialog ReDraw hDlg
            Case %IDM_ControlDelete : DeleteContextControl

         End Select
   End Select
End Function

Sub CreateImageList
    DebugLog("CreateImageList")
    ImageList New Icon 24,24,32,3 To hImageList
    ImageList Add Icon hImageList, "button"                  '1
    ImageList Add Icon hImageList, "checkbox"                '2
    ImageList Add Icon hImageList, "combobox"                '3
    ImageList Add Icon hImageList, "frame"                   '4
    ImageList Add Icon hImageList, "graphic"                 '5
    ImageList Add Icon hImageList, "image"                   '6
    ImageList Add Icon hImageList, "imagex"                  '7
    ImageList Add Icon hImageList, "imgbutton"               '8
    ImageList Add Icon hImageList, "imgbuttonx"              '9
    ImageList Add Icon hImageList, "label"                   '10
    ImageList Add Icon hImageList, "line"                    '11
    ImageList Add Icon hImageList, "listbox"                 '12
    ImageList Add Icon hImageList, "listview"                '13
    ImageList Add Icon hImageList, "option"                  '14
    ImageList Add Icon hImageList, "progressbar"             '15
    ImageList Add Icon hImageList, "hscrollbar"              '16
    ImageList Add Icon hImageList, "vscrollbar"              '17
    ImageList Add Icon hImageList, "richtextbox"             '18
    ImageList Add Icon hImageList, "statusbar"               '19
    ImageList Add Icon hImageList, "tab"                     '20
    ImageList Add Icon hImageList, "textbox"                 '21
    ImageList Add Icon hImageList, "toolbar"                 '22
    ImageList Add Icon hImageList, "treeview"                '23
    ImageList Add Icon hImageList, "copy"                    '24
    ImageList Add Icon hImageList, "select"                  '25
    ImageList Add Icon hImageList, "new"                     '26
    ImageList Add Icon hImageList, "undo"                    '27
    ImageList Add Icon hImageList, "mode"                    '28
    ImageList Add Icon hImageList, "select"                  '29
    ImageList Add Icon hImageList, "open"                    '30
    ImageList Add Icon hImageList, "saveas"                  '31
    ImageList Add Icon hImageList, "Save"                    '32
    ImageList Add Icon hImageList, "deleteall"               '33
    ImageList Add Icon hImageList, "codebox"                 '34
    ImageList Add Icon hImageList, "leftright"               '35
    ImageList Add Icon hImageList, "linemode"                '36
    ImageList Add Icon hImageList, "LeftRight"               '37
    ImageList Add Icon hImageList, "ShowCode"                '38
    ImageList Add Icon hImageList, "BringToTop"              '39
    ImageList Add Icon hImageList, "CheckState"              '40
    ImageList Add Icon hImageList, "edit"                    '41
    ImageList Add Icon hImageList, "run"                     '42


End Sub

Sub SetToTrueSize(i As Long)
    DebugLog("SetToTrueSize")
   'image resizes itself to fit the image, so we must store the automatic resize values
   Local w,h As Long
   Control Get Size hDlg, cList(i).cID To w,h
   cList(i).x2 = cList(i).x1 + w
   cList(i).y2 = cList(i).y1 + h
End Sub

Sub ResizeToolbar
    DebugLog("Resize")
    Local i As Long
    If ExpandToolbar Then
        For i = 2 To 13 : Toolbar Set State hDlg, %IDC_ToolbarA, i, %TBState_Enabled : Next i
        Toolbar Add Separator hDlg, %IDC_ToolbarA, 20 At 6   'separator
        Toolbar Add Separator hDlg, %IDC_ToolbarA, 20 At 9   'separator
        Toolbar Add Separator hDlg, %IDC_ToolbarA, 20 At 12   'separator
        Toolbar Add Separator hDlg, %IDC_ToolbarA, 20 At 17   'separator
    Else
        Toolbar Delete Button hDlg, %IDC_ToolbarA, 17   'separator
        Toolbar Delete Button hDlg, %IDC_ToolbarA, 12   'separator
        Toolbar Delete Button hDlg, %IDC_ToolbarA, 9   'separator
        Toolbar Delete Button hDlg, %IDC_ToolbarA, 6   'separator
        For i = 2 To 13 : Toolbar Set State hDlg, %IDC_ToolbarA, i, %TBState_Hidden : Next i
    End If
    Control ReDraw hDlg, %IDC_ToolbarA
End Sub

Sub BringToTop
    DebugLog("BringToTop")
    Local i As Long, tempControl As ControlType
    If ContextControl = 0 Then Exit Sub
    'graphic
    BringWindowToTop cList(ContextControl).Handle
    'array (put contextcontrol at end of array, which is 1st on tab order
    tempControl = cList(ContextControl)
    For i = ContextControl To UBound(cList)-1
        cList(i) = cList(i+1)
    Next i
    cList(UBound(cList)) = tempControl
    CreateCode       'code matches tab order
    RefreshDrawing
End Sub

Sub CreateCodeImageList
    DebugLog("CreateCodeImageList")
   ImageList New Icon 16,16,24,3 To hCodeLst
   ImageList Add Icon hCodeLst, "open"              '1
   ImageList Add Icon hCodeLst, "save"              '2
   ImageList Add Icon hCodeLst, "x"              '1
   ImageList Add Icon hCodeLst, "y"              '2
End Sub

Sub LoadDialogTemplate
    DebugLog("LoadDialogTemplate")
   Open "gbDesigner_DialogCode.txt" For Binary As #1
   Get$ #1, Lof(1), dialogtemplate
   Close #1
End Sub

Sub LoadControlCode
    DebugLog("LoadControLCode")
   Local i, iPosA, iPosB As Long, temp$

   'read the whole thing
   Open EXE.Path$ + "gbDesigner_ControlCode.txt" For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1

   Dim tempArray(ParseCount(temp$,"::::")) As String
   Parse temp$, tempArray(), "::::"

   For i = 1 To UBound(tempArray)
       iPosA = InStr(1, tempArray(i), $CrLf)
       iPosB = InStr(iPosA+2, tempArray(i), $CrLf)
       ControlCodeStd(400+i) = Mid$(tempArray(i),iPosA+2,iPosB-iPosA)
       ControlCodeExp(400+i) = Mid$(tempArray(i),iPosB+2)
   Next i

End Sub

Sub OpenInIDE
    DebugLog("OpenInIDE")
    Local fName As Asciiz * %Max_Path, iReturn As Long
    fName = EXE.Path$ + "gbDesigner_temp.bas"
    Open fName For Output As #1
    Print #1, cCode
    Close #1
    iReturn = ShellExecute(hDlg, "Open", fName, $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub DisplayControlData(i As Long)
    Local temp$
    temp$ = ControlNames(cList(i).cType)
    temp$ = temp$ + $CrLf + cList(i).cName
    temp$ = temp$ + $CrLf + "Location:  " + Trim$(Str$(cList(i).x1)) + "," + Str$(cList(i).y1)
    temp$ = temp$ + $CrLf + "Size:  " + Str$(cList(i).x2 - cList(i).x1) + "," + Str$(cList(i).y2 - cList(i).y1)
    MsgBox temp$, %MB_Ok + %MB_IconInformation, "Control Information"
End Sub

Sub RearrangeCList
    Local i, j, iCount As Long
    Dim zList(UBound(cList)) As ControlType

    'create zList to match the re-order dialog results
    ListBox Get Count hOrder, %IDC_zListBox To iCount
    For i = 1 To iCount
        ListBox Get User hOrder, %IDC_zListBox, i To j
        Control Kill hDlg, cList(j).cID
        zList(i) = cList(j)
    Next i

    'rebuild cList and re-create all controls
    ReDim cList(UBound(zList))
    For i = 1 To UBound(cList)
       cList(i) = zList(i)
       cList(i).cId = BaseID + i
       AddNewControl i, 0   '1=new cID 0=same cID
    Next i
    CreateCode
    RefreshDrawing
    DisplayCaption
End Sub
